# SlideYourNet

Slide your networks fetches social network posts and agregates them in a slideshow

## Install instructions

1. Copy files or clone repo
2. Create a database and import `/sql/slideyournet.sql`
3. Rename `config-sample.php` into `config.php` and edit it with the correct variables
4. Install dependencies with composer `composer install`
5. That's it!

## Usage

Create a session from the front page, you will be redirected to the admin page.

The admin-page's URL contains the session name and the token

## API usage

fetched datas can be used by an external service using the **name** and the **token** of each session.

### RSS

Only main stream can be fetched in RSS format

http://yourdomain.com/rss.php?s=`session_name`&t=`session_token`

### JSON

the base URL for JSON API is:

http://yourdomain.com/api.php?s=`session_name`&t=`session_token`

key | value |
----|-------|
s  | Your instance's name |
t  | Your instance's token |

Additional parameters have to be added:

#### Posts

key | value |
----|-------|
object|post|
type|stat or get|

- **Stats** *Total number of filtered posts*
- **Stream** *A list of filtered posts*

Filter parameters

key | value |
----|-------|
network |	empty, twitter or instagram|
username | 	empty or user's name|
status| 	1 or 0|
after| 	empty or date 0000-00-00 00:00:00|
before| 	empty or date 0000-00-00 00:00:00|
minid| 	empty or integer|
maxid |	empty or integer|
item_id| 	empty or integer|
order| 	DESC or ASC|
order_by| 	pub_date, id, content|
per_page| 	default : 10|
page| 	default 1|


#### Users

key | value |
----|-------|
object|user|
type|get|

Filter parameters

key | value |
----|-------|
network |	empty, twitter or instagram|
status| 	1 or 0|
minid| 	empty or integer|
maxid |	empty or integer|
order| 	DESC or ASC|
order_by| 	pub_date, id, content|
per_page| 	default : 10|
page| 	default 1|


