<?php
require('../ecologram.php');
$eg->check_token();
if ($eg->config['use_subdomains'] && 'admin.' . $eg->server_name !== $eg->host) {
    header('location: ' . $eg->server_protocol . '://admin.' . $eg->server_name . $eg->config['base_path'] . 'admin?s=' . $eg->session->name . '&t=' . $eg->session->token);
    exit();
}
$networks = $eg->get_networks();
$nets = 0;
foreach ($networks as $net_name => $network) {
    if ($network['status'] == 1) {
        $nets++;
    }
}
?><!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8">
        <link rel="stylesheet" href="<?php echo $eg->base_url; ?>vendor/twbs/bootstrap/dist/css/bootstrap.min.css" />
        <link rel="stylesheet" href="<?php echo $eg->base_url; ?>/css/ecologram-admin.css" />
        <link rel="stylesheet" href="<?php echo $eg->base_url; ?>/css/dashicons.min.css" />
        <link rel="shortcut icon" href="<?php echo $eg->base_url; ?>/img/slideyournet-icon.png" />
        <link rel="apple-touch-icon" href="<?php echo $eg->base_url; ?>/img/slideyournet-icon.png"/>
        <link href="//cdn.rawgit.com/noelboss/featherlight/master/release/featherlight.min.css" type="text/css" rel="stylesheet" title="Featherlight Styles" />
        <title><?php echo $eg->session->name; ?> - <?php echo $eg->title; ?></title>
    </head>
    <body id="admin-index" class="admin-index admin-page row-fluid">
        <div id="page">
            <?php include('header.php'); ?>
            <div id="content" class="row">

                <?php if ($nets == 0): ?>

                    <div class="message">
                        <div class="col-md-1"></div>
                        <div class="col-md-10 text-center">
                            <p class="alert alert-warning">
                                <?php _e('You have not configured any network, please go to the subscription page to add one (at least).'); ?>
                            </p>
                            <a class="btn btn-primary btn-lg" href="<?php echo $eg->admin_url; ?>networks.php?s=<?php echo $eg->session->name; ?>&t=<?php echo $eg->session->token; ?>">
                                <?php _e('Add a network'); ?>
                            </a>
                        </div>
                    </div>

                <?php else: ?>

                    <div class="col-md-2 col-sm-3 hidden-xs" id="userszone">
                        <h2><?php _e('Users'); ?></h2>
                        <div class="column_wrap">
                            <ul id="users" class="infinite-scroll">

                            </ul>
                        </div>
                        <a class="more" data-action="users" id="more_users"><?php _e('More'); ?></a>
                        <div class="" id="userinfo"></div>
                    </div>
                    <div class="col-md-10 col-sm-9" id="itemszone">
                        <h2><?php _e('Items'); ?> <span id="itemsstat"></span></h2>
                        <div id="shown">
                            <button><?php _e('Currently displayed'); ?></button>
                            <div id="displayed" class="items_list" class="infinite-scroll">

                            </div>
                        </div>
                        <div class="column_wrap">
                            <div id="items" class="items_list row infinite-scroll">

                            </div>
                        </div>
                        <a class="more" data-action="items" id="more_items"><?php _e('More'); ?></a>
                    </div>
                <?php endif; ?>

            </div>
        </div>

        <div id="admin">

            <div id="panel">
                <div class="row">
                    <div class="col-md-12">
                        <label>
                            <?php _e('Admin link'); ?>
                            <input class="adminlink form-control" type="text" value="<?php echo $eg->server_protocol; ?>://<?php echo $eg->server_name . $eg->config['base_path'] . 'admin?s=' . $eg->session->name . '&t=' . $eg->session->token; ?>" onfocus="this.select()"/>
                        </label>
                    </div>
                    <div class="col-md-12">
                        <label>
                            <?php _e('Session name'); ?>
                            <input class="adminlink form-control" type="text" value="<?php echo $eg->session->name; ?>" onfocus="this.select()"/>
                        </label>
                    </div>
                    <div class="col-md-12">
                        <label>
                            <?php _e('Token'); ?>
                            <input class="adminlink form-control" type="text" value="<?php echo $eg->session->token; ?>" onfocus="this.select()"/>
                        </label>
                    </div>
                </div>

                <hr>

                <div class="row">
                    <div class="col-md-12">
                        <label><?php _e('Size'); ?>
                            <select id="as" class="form-control">
                                <option value="0.5"><?php _e('Ultra slim'); ?></option>
                                <option value="0.6"><?php _e('Slim'); ?></option>
                                <option value="0.7"><?php _e('Small'); ?></option>
                                <option value="0.8" selected><?php _e('Normal'); ?></option>
                                <option value="0.9"><?php _e('Large'); ?></option>
                                <option value="1"><?php _e('Big'); ?></option>
                                <option value="1.1"><?php _e('Mole'); ?></option>
                            </select>
                        </label>
                    </div>
                    <div class="col-md-12">
                        <label><?php _e('Refresh users'); ?>
                            <select id="rur" class="form-control">
                                <option value="5">5 sec.</option>
                                <option value="10">10 sec.</option>
                                <option value="20">20 sec.</option>
                                <option value="30" selected>30 sec.</option>
                                <option value="60">1 min.</option>
                                <option value="120">2 min.</option>
                                <option value="600">10 min.</option>
                            </select>
                        </label>
                    </div>
                    <div class="col-md-12">
                        <label><?php _e('Refresh items'); ?>
                            <select id="rir" class="form-control">
                                <option value="5">5 sec.</option>
                                <option value="10">10 sec.</option>
                                <option value="20" selected>20 sec.</option>
                                <option value="30">30 sec.</option>
                                <option value="60">1 min.</option>
                                <option value="120">2 min.</option>
                                <option value="600">10 min.</option>
                            </select>
                        </label>
                    </div>
                </div>
            </div>

        </div>
        <script>
            var is_in_console = false;
        </script>
        <?php $eg->admin_scripts(); ?>

    </body>
</html>
