<?php
if (!class_exists('ecologram')) {

    class ecologram {
        public $debug;

        //Params
        public $config;
        public $version;
        public $server_name;
        public $server_protocol;
        public $version_manager;
        //Cache stuff
        public $users_cache;
        public $users_cache_id;
        //Sessions stuffp
        public $session;
        public $title;
        public $template;
        public $templates;
        public $lang;
        //Networks
        public $networks;
        public $networks_old;
        public $networks_path;
        //Machine
        public $server;
        public $php;
        public $sql;
        public $host;
        public $script_name;
        public $current_path;
        public $query_string;
        public $file_name;
        public $scripts = array();
        public $ajax_scripts = array();
        //SU
        public $suUsername;
        public $suPassword;
        // Models
        public $_Items;

        function ecologram(){
            $this->__construct();
        }
        function __construct() {

            //Machine
            define('CLI', php_sapi_name() === "cli");
            $this->php = phpversion();
            $this->file_name = basename($this->script_name);
            $this->title = 'Slide Your Net';
            $this->template = 'main';
            $this->session = false;
            $this->templates = array(
                'slide',
                'stream',
                'pix',
                'live'
            );

            if (!defined('ABS_PATH'))
                define('ABS_PATH', dirname(__FILE__) . '/');
            global $conf, $conn;
            $conf = array();

            require ABS_PATH . 'config.php';
            if(CLI){
              $this->server = 'cli';
              $this->host = $conf['server_name'];
              $this->script_name = '';
              $this->current_path = '';
              $this->query_string = '';
            }
            else{
              $this->server = isset($_SERVER['SERVER_SOFTWARE']) && strstr($_SERVER['SERVER_SOFTWARE'], 'nginx') ? 'nginx' : 'apache';
              $this->host = $this->server == 'nginx' ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME'];
              $this->script_name = $_SERVER['SCRIPT_NAME'];
              $this->current_path = $_SERVER['REQUEST_URI'];
              $this->query_string = $_SERVER['QUERY_STRING'];
            }
            require ABS_PATH . 'vendor/autoload.php';
            require ABS_PATH . 'includes/gettext.php';
            require ABS_PATH . 'includes/utils.php';
            require ABS_PATH . 'includes/screenshot.php';

            $this->config = $conf;

            if(isset($this->config['debug']) && $this->config['debug']){
                $this->debug =true;
                ini_set('display_errors', 1);
            }
            else{
                ini_set('display_errors', 0);
            }
            session_name('3col0Gr4m');
            session_start();

            $this->messages = require ABS_PATH . 'includes/messages.php';

            $conn = mysqli_connect($conf['db_host'], $conf['db_user'], $conf['db_pass']);
            $this->mysqli = $conn;
            if(!$conn || !mysqli_select_db($this->mysqli, $conf['db_base'])){
                echo 'Connection error';
                exit;
            }

            // Models
            require ABS_PATH . 'includes/models/_model.php';

            #Fix 01.2020: Issue with the session admin on the function front (url)
            $pos1 = strpos($this->current_path, "/admin/");
            $pos2 = strpos($this->current_path, "/su/");

            if ($pos1 === false && $pos2 === false) {
              $this->front();
            }

            $this->users_cache = array();
            date_default_timezone_set($conf['timezone']);

            $this->suUsername = isset($conf['su']['username']) && !empty($conf['su']['username']) ? $conf['su']['username'] : false;
            $this->suPassword = isset($conf['su']['password']) && !empty($conf['su']['password']) ? $conf['su']['password'] : false;

            $this->server_name = isset($conf['server_name']) && !empty($conf['server_name']) ? $conf['server_name'] : $this->host;
            $this->server_protocol = isset($conf['server_protocol']) && !empty($conf['server_protocol']) ? $conf['server_protocol'] : 'http';

            $this->networks_path = ABS_PATH . 'includes/networks/';

            $this->base_url = $this->server_protocol . '://' . $this->server_name . '/';
            $this->admin_url = $this->server_protocol . '://' . ($this->config['use_subdomains'] ? 'admin.' : '') . $this->server_name . '/admin/';

            $server_auth = (isset($conf['server_auth']) && !empty($conf['server_auth']) ? $conf['server_auth'].'@' : '' );
            $this->full_base_url = $this->server_protocol . '://' . $server_auth . $this->server_name . '/';
            $this->full_admin_url = $this->server_protocol . '://' . $server_auth . ($this->config['use_subdomains'] ? 'admin.' : '') . $this->server_name . '/admin/';

            $this->current_url = $this->server_protocol . '://' . $this->host . '/' . $this->script_name;
            $this->current_url_query = $this->server_protocol . '://' . $this->host . '/' . $this->script_name . '?' . $this->query_string;

            //Networks
            $this->networks = array();
            $available_networks = scandir($this->networks_path);
            $php_cache = "<?php\n";
            foreach ($available_networks as $network) {
                if (is_dir($this->networks_path . $network) && file_exists($this->networks_path . $network . '/settings.json')) {
                    $network_settings = json_decode(file_get_contents($this->networks_path . $network . '/settings.json'));
                    $this->networks[$network] = array(
                        'active' => 0,
                        'status' => 0,
                        'settings' => $network_settings,
                    );
                    if (isset($_GET['force_cache'])) {
                        foreach ($network_settings as $key => $atts) {
                            $php_cache.="\n// $key\n";
                            foreach ($atts as $att => $att_name) {
                                if(!in_array($att, array('label', 'values', 'description', 'name'))){
                                    continue;
                                }
                                if (is_array($att_name) || is_object($att_name)) {
                                    foreach ($att_name as $k => $val) {
                                        $php_cache.="//$k\n__('$val');\n";
                                    }
                                }
                                else {
                                    $php_cache.="//$att\n__('$att_name');\n";
                                }
                            }
                        }
                    }
                }
            }
            $php_cache.='';
            if (isset($_GET['force_cache'])) {
                $root = __DIR__;
                if(basename($root)=='admin'){
                    $root = str_replace('/admin', '', $root);
                }
                $path = $root.'/var/cache/settings.php';
                $fp=fopen($path, 'w+');
                fwrite($fp, $php_cache);
                fclose($fp);
            }
            $this->load_networks();
            if (!$this->is_admin()) {
                $this->front_post();
            }

            $lang_string = isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) ? $_SERVER['HTTP_ACCEPT_LANGUAGE'] : 'fr';
            $langs = explode(',', $lang_string);
            $prefered_lang = $langs[0];
            if (strlen($prefered_lang) == 2) {
                $prefered_lang = strtolower($prefered_lang) . '_' . strtoupper($prefered_lang);
            }
            if (substr($prefered_lang,2,1) == '-') {
                $prefered_lang = str_replace('-','_',$prefered_lang);
            }
            set_language($prefered_lang);
            $this->lang = $prefered_lang;
            $this->load_version();

        }

        function get_config(){
            return $this->config;
        }

        // Singletons
        function Item(){
            if(!$this->_Items){
                require ABS_PATH . 'includes/models/items.php';
                $this->_Items = new Item_Manager;
            }
            return $this->_Items;
        }

        // Function picture or avatar TEST

        function picture_exists(){

            //Connect and verify if picture exists
            $picture_test = $this->current_path;

            preg_match_all("/(.*\/)?([a-z]+)\/([a-z]+)\/([0-9]+).*/", $picture_test, $result);

            if(isset($result[2][0]) && isset($result[3][0]) && isset($result[4][0])){
                $this->debug =false;
                $this->set_session($result[2][0]);
                if($result[3][0]=='user'){
                   $user = $this->get_user_by_id($result[4][0], true);
                   if($user){
                     $result_test = @file_get_contents($user->avatar_url);
                     if ($result_test !=NULL) {
                        header('Content-Type: image/png');
                        print $result_test;
                        exit;
                     }
                     // If not exists replace the picture by the new url of the new picture
                     else {
                        $user = $this->update_user_from_remote($user);
                     }

                   }
                }
                elseif($result[3][0]=='item'){
                   $items = $this->get(['item_id'=>$result[4][0]]);
                   if($items && $items[0]){
                     $item=$items[0];
                     $result_test = @file_get_contents($item->media_url);
                     if ($result_test !=NULL) {
                        header('Content-Type: image/png');
                        print $result_test;
                        exit;
                     }
                     // TODO: If not exists replace the picture by the new url of the new picture
                     else {
                        exit;
                     }

                   }
                }
                exit;
            }
        }

        function update_user_from_remote($user){
            $this->set_session($user->session_id);
            switch ($user->network) {
              case 'twitter':
                include_once('includes/networks/twitter/auth.php');
                global $SYNTwitter;
                try{
                  $remote_user = $SYNTwitter->get_user( !empty($user->external_id) ? $user->external_id : $user->name);
                  $maybe_new_user = $this->register_user(array(
                      'id'=>$user->id,
                      'network'=>$user->network,
                      'username'=>$remote_user->screen_name,
                      'external_id'=>$remote_user->id,
                      'user_avatar'=>$remote_user->profile_image_url_https,
                      'user_description'=>$remote_user->description,
                      'user_city'=>$remote_user->location,
                  ));
                  if($maybe_new_user){
                    $user = $maybe_new_user;
                  }
                }
                catch(\Exception $e){

                }
                break;

              case 'instagram':
                    include_once('includes/networks/instagram/instagram.php');
                    try{
                      $ig = new InstaLegacy;
                      if(false != $remote_user = $ig->get(array('type'=>'user', 'query'=>$user->external_id, 'force'=>true))){
                        $remote_user['id'] = $user->id;
                        $maybe_new_user = $this->register_user($remote_user);
                        if($maybe_new_user){
                          $user = $maybe_new_user;
                      }
                    }
                  }
                  catch(\Exception $e){

                  }
                    break;
              default:
                // code...
                break;
            }
            // die();
            return $user;
        }

        function load_version(){
            require_once ABS_PATH . 'includes/version_manager.php';
            $this->version_manager = new SYN_Version_Manager($this);
            $this->version = $this->version_manager->current;
        }

        function is_admin() {
            return basename(dirname(__FILE__)) == 'admin';
        }

		function to_session(){
			$_SESSION['eg_s'] =  $this->session->name;
			$_SESSION['eg_t'] =  $this->session->token;
		}
		function from_session(){
			if(((!isset($_GET['s']) && !isset($_GET['t'])) || ($_GET['s'] == 'undefined' && $_GET['t'] == 'undefined')) && isset($_SESSION['eg_s']) && isset($_SESSION['eg_t']) && $_SESSION['eg_s'] && $_SESSION['eg_t']){
				$_REQUEST['s'] = $_GET['s'] = $_SESSION['eg_s'];
				$_REQUEST['t'] = $_GET['t'] = $_SESSION['eg_t'];
				unset($_SESSION['eg_s']);
				unset($_SESSION['eg_t']);
			}
		}

        function db_where() {
            if (!$this->session)
                return '';

            return "`session_id`='" . $this->session->id . "' AND";
        }

        function check_token() {
            if (isset($_REQUEST['s']) && isset($_REQUEST['t'])) {
                $req = "SELECT
                *
            FROM
                `" . $this->config['db_prefix'] . "sessions`
            WHERE
                `name`='" . addslashes($_REQUEST['s']) . "'
                AND `token`='" . addslashes($_REQUEST['t']) . "' ";
                if (false !== ($res = mysqli_query($this->mysqli, $req)) && mysqli_num_rows($res) == 1) {
                    $this->session = mysqli_fetch_object($res);
                    $this->lang = $this->session->lang;
                    $this->load_networks();
                    set_language($this->lang);
                    return true;
                }
            }
            header("HTTP/1.0 404 Not Found");
            $this->template('404');
            exit;
        }

        /*
         * set_session
         * Force to modify current session without token
         *
         * @param $session_name
         *
         * @return bool
         *
         */

        function set_session($session_name) {
            $req = "SELECT
                *
            FROM
                `" . $this->config['db_prefix'] . "sessions`
            WHERE
                `".(is_numeric($session_name) ? 'id' : 'name')."`='" . addslashes($session_name) . "'";
            if (false !== ($res = mysqli_query($this->mysqli, $req)) && mysqli_num_rows($res) == 1) {
                $this->session = mysqli_fetch_object($res);
                $this->load_networks();
                return true;
            }
            return false;
        }

        /*
         * list_sessions
         * @param $parameters (array)
         * 	*	@param active (bool)
         * 	*	@param return (array of columns to get, default=name)
         *
         *
         * @return an arrray of sessions
         *
         */

        function list_sessions($params = array()) {
            $where = '';
            $orderby = '';
            $groupby = '';
            $limit = '';
            $from = "`{$this->config['db_prefix']}sessions` s";
            $what = 's.`name`';
            $custom_what = false;
            if (isset($params['active']) && $params['active']!='') {
                $now = date('Y-m-d H:i:s');
                if ($params['active'] == true) {
                    $from .= " JOIN `{$this->config['db_prefix']}networks` n ON n.session_id=s.id";
                    $where.="AND
          (s.`date_begin` IS NULL OR s.`date_begin`='0000-00-00 00:00:00' OR s.`date_begin`<='" . $now . "')
          AND
          (s.`date_end` IS NULL OR s.`date_end`='0000-00-00 00:00:00' OR s.`date_end`>='" . $now . "')
          AND
          n.`status`=1
          AND
          n.`preferences` IS NOT NULL
          ";
                    $groupby=' GROUP BY s.`id`';
                }
                elseif ($params['active'] == false) {
                    $where.="AND (
            (s.`date_begin`!= NULL AND s.`date_begin`>='" . $now . "')
            OR
            (s.`date_end`!= NULL OR s.`date_end`<='" . $now . "')
          )
        ";
                }
            }
            if (isset($params['name']) && !empty($params['name'])) {
                $where.="AND s.`name`='" . addslashes($params['name']) . "'";
            }
            elseif (isset($params['search']) && !empty($params['search'])) {
                $where.="AND s.`name` LIKE '%" . addslashes($params['search']) . "%'";
            }
            if (isset($params['return']) && is_array($params['return']) && sizeof($params['return']) > 0) {
                $what = '';
                foreach ($params['return'] as $return) {
                  if(strstr($return, '`')){
                    $what.=$return.',';
                  }
                  else{
                    $what.='s.`' . $return . '`,';
                  }
                }
                $what = substr($what, 0, -1);
                $custom_what = true;
            }
            if(isset($params['orderby'])){
              $orderby = 'ORDER BY '.$params['orderby'];
            }
            if(isset($params['limit'])){
              $limit = 'LIMIT '.$params['limit'];
            }

            $sessions = array();
            $req = "SELECT
                {$what}
            FROM
                {$from}
            WHERE
                1 {$where}
            {$groupby}
            {$orderby}
            {$limit}";
            if (false !== ($res = mysqli_query($this->mysqli, $req)) && mysqli_num_rows($res) > 0) {
                while ($session = mysqli_fetch_object($res)) {
                    if ($custom_what == true)
                        $sessions[] = $session;
                    else
                        $sessions[] = $session->name;
                }
            }
            return $sessions;
        }

        function load_networks() {
            if (!$this->session)
                return '';

            $this->networks = $this->get_networks();
            $this->networks_old = (array) $this->networks;
        }

        function get_networks($session_id = null) {
            if (!$session_id && $this->session) {
                $session_id = $this->session->id;
            }
            if (!is_numeric($session_id) || $session_id <= 0) {
                return array('no session');
            }

            if(is_array($this->networks_old) && !empty($this->networks_old)){
                return $this->networks;
            }

            $networks = $this->networks;
            foreach ($this->networks as $network => $attributes) {
                $req = "SELECT `id`,`status`,`preferences` FROM `" . $this->config['db_prefix'] . "networks` WHERE `session_id`=$session_id AND `name`='" . $network . "'";
                $res = mysqli_query($this->mysqli, $req);
                if ($res && mysqli_num_rows($res) > 0) {
                    $preferences = mysqli_fetch_array($res);
                    $networks[$network]['id'] = $preferences[0];
                    $networks[$network]['active'] = 1;
                    $networks[$network]['status'] = $preferences[1];
                    $networks[$network]['options'] = unserialize($preferences[2]);
                }
            }
            return $networks;
        }

        function front_post() {
            if (!isset($_POST))
                return;

            if (isset($_POST['action'])) {
                switch ($_POST['action']) {
                    case 'create':
                        $error_messages = [];
                        if (!is_post('name')) {
                            $error_messages[] = 'message[]=1';
                        }
                        if (!is_post('accept_tos')) {
                            $error_messages[] = 'message[]=7';
                        }

                        if(!empty($error_messages)){
                            redirect($this->current_url . '?'.implode('&', $error_messages));
                        }
                        else {
                            $name = preg_replace('/[^a-z[0-9]+/', '-', strtolower(stripslashes($_POST['name'])));
                            $check_existing = $this->list_sessions(array('name' => $name));
                            if (sizeof($check_existing) > 0) {
                                redirect($this->current_url . '?message[]=2');
                            }

                            $token = md5(time());
                            $req = "INSERT INTO `" . $this->config['db_prefix'] . "sessions` (`name`,`token`) VALUES ('" . $name . "','" . $token . "')";
                            if (mysqli_query($this->mysqli, $req)) {
                                redirect($this->admin_url . 'networks/?s=' . $name . '&t=' . $token);
                            }
                            else{
                                redirect($this->current_url . '?message[]=0&message[]='.mysqli_error($this->mysqli));
                            }

                            redirect($this->current_url . '?message[]=0');
                        }
                        break;
                }
            }
        }

        function admin_post() {
            if (!isset($_POST))
                return;


            // Settings
            if (isset($_POST['session']['mod'])) {
                // Networks
                if (isset($_POST['networks'])) {
                    foreach ($this->networks as $network => $attributes) {
                        if (isset($_POST['networks'][$network])) {
                            $status = isset($_POST['networks_status'][$network]) ? 1 : 0;
                            $options = serialize($_POST['networks'][$network]);
                            if ($attributes['active'] == 1) {
                                $req = "UPDATE `" . $this->config['db_prefix'] . "networks` SET `status`='" . $status . "', `preferences`='" . $options . "' WHERE " . $this->db_where() . " `name`='" . $network . "'";
                            }
                            else {
                                $req = "INSERT INTO `" . $this->config['db_prefix'] . "networks` (`session_id`,`name`,`status`,`preferences`) VALUES ('" . $this->session->id . "','" . $network . "','" . $status . "','" . $options . "') ";
                            }

                            if (mysqli_query($this->mysqli, $req)) {
                                $this->networks[$network]['status'] = $status;
                                $this->networks[$network]['options'] = unserialize(stripcslashes($options));
                            }
                        }
                    }
                }
                $req = "UPDATE `" . $this->config['db_prefix'] . "sessions` SET "
                        . " `mod`='" . abs($_POST['session']['mod']) . "',"
                        . "`snapshot`='" . abs($_POST['session']['snapshot']) . "', "
                        . "`duplicate`='" . abs($_POST['session']['duplicate']) . "', "
                        . "`empty`='" . abs($_POST['session']['empty']) . "', "
                        . "`advanced_repost`='" . abs($_POST['session']['advanced_repost']) . "' "
                        . "WHERE `id`='" . $this->session->id . "'";
                header('location: '.$this->admin_url.'networks/?'.  http_build_query(array(
                    's'=>$this->session->name,
                    't'=>$this->session->token,
                    'message'=>mysqli_query($this->mysqli, $req) ? 6 : 4
                )));
            }
            // Advanced
            if(filter_input(INPUT_POST, 'syn-form')=='advanced'){
                $req = "UPDATE `" . $this->config['db_prefix'] . "sessions` SET "
                        . " `date_begin`='" . date('Y-m-d : H:i:s', strtotime($_POST['session']['date_begin'])) . "',"
                        . " `date_end`='" . date('Y-m-d : H:i:s', strtotime($_POST['session']['date_end'])) . "'"
                        . "WHERE `id`='" . $this->session->id . "'";
                header('location: advanced.php?'.  http_build_query(array(
                    's'=>$this->session->name,
                    't'=>$this->session->token,
                    'message'=>mysqli_query($this->mysqli, $req) ? 5 : 4
                )));
            }
        }

        function print_messages() {
            if (is_request('message')) {
                if (is_numeric($_REQUEST['message']) && isset($this->messages[$_REQUEST['message']])) {
                    echo '<div class="eg_alert ' . $this->messages[$_REQUEST['message']]['class'] . '">' . $this->messages[$_REQUEST['message']]['text'] . '</div>';
                }
                elseif (is_array($_REQUEST['message'])) {
                    foreach ($_REQUEST['message'] as $message_id) {
                        if (isset($this->messages[$message_id])) {
                            echo '<div class="eg_alert ' . $this->messages[$message_id]['class'] . '">' . $this->messages[$message_id]['text'] . '</div>';
                        }
                    }
                }
            }
        }

        function is_active($session){
            $now = time();
            return (
                    ($session->date_begin == NULL && $session->date_end == NULL)
                    ||
                    (strtotime($session->date_begin)<$now && strtotime($session->date_end)>$now)
                   );
        }

        /** Users * */
        function get_user($user, $network = '', $user_avatar = '', $user_description = '', $user_city = '', $external_id = '') {
            if (!$this->session)
                return false;

            $auto_create = true;

            if (is_array($user)) {
                $user_array = $user;
                $username = isset($user_array['username']) ? $user_array['username'] : '';
                $network = isset($user_array['network']) ? $user_array['network'] : '';
                $user_avatar = isset($user_array['user_avatar']) ? $user_array['user_avatar'] : '';
                $user_description = isset($user_array['user_description']) ? $user_array['user_description'] : '';
                $user_city = isset($user_array['user_city']) ? $user_array['user_city'] : '';
                $external_id = isset($user_array['external_id']) ? $user_array['external_id'] : '';
                if(isset($user_array['no_create']) && $user_array['no_create']!=false){
                  $auto_create = false;
                }
            }
            else {
                $username = $user;
                $user_array = array(
                    'username' => $username,
                    'network' => $network,
                    'user_avatar' => $user_avatar,
                    'user_description' => $user_description,
                    'user_city' => $user_city,
                    'external_id' => $external_id,
                );
            }
            $user = (object) $user_array;
            $search_key = 'name';
            $search_value = $username;
            if($external_id){
              $search_key = 'external_id';
              $search_value = $external_id;
            }
            if (!empty($search_value) && !empty($network)) {
                $update_fields = array();
                if(isset($user->id) && $user->id){
                  if ($user_avatar != '' && $user_avatar != $user->avatar_url) {
                    $update_fields[]="`avatar_url`='" . addslashes($user_avatar) . "'";
                  }
                  if ($user_description != '' && $user_description != $user->user_description) {
                    $update_fields[]="`user_description`='" . addslashes($user_description) . "'";
                  }
                  if ($user_city != '' && $user_city != $user->user_city) {
                    $update_fields[]="`user_city`='" . addslashes($user_city) . "'";
                  }
                  if ($external_id != '' && $external_id != $user->external_id) {
                    $update_fields[]="`external_id`='" . addslashes($external_id) . "'";
                  }
                }
                $cache_key = $network.'/'.$username;
                if (isset($this->users_cache[$cache_key])) {
                    $user = $this->users_cache[$cache_key];
                    //If no changes, then retrun existing user
                    if (empty($update_fields)) {
                        return $this->users_cache[$cache_key];
                    }
                }

                $req = "SELECT * FROM `" . $this->config['db_prefix'] . "users` WHERE " . $this->db_where() . " `".$search_key."`='" . addslashes($search_value) . "' AND `network`='" . addslashes($network) . "' ";
                $res = mysqli_query($this->mysqli, $req);
                if ($res && mysqli_num_rows($res)) {
                    $user = mysqli_fetch_object($res);
                }
                elseif($username && $auto_create){
                    $user = $this->register_user($user_array);
                }
                if(!$user || !isset($user->id)){
                  return false;
                }

                // UPDATE CHANGED FIELDS
                if ($user && count($update_fields)) {
                    $req = "UPDATE
					`" . $this->config['db_prefix'] . "users`
				SET
					 " . implode(',', $update_fields) . "
				WHERE
					`id`='" . abs($user->id) . "' ";
                    $res = mysqli_query($this->mysqli, $req);
                    //echo $req;
                    $user = $this->get_user($username, $network);
                }

                $cache_key = $network.'/'.$username;
                $this->users_cache[$cache_key] = $user;
                $this->users_cache_id[$user->id] = $user;
                return $user;
            }
            return false;
        }

        function get_user_by_id($userid, $public=false) {
            if (!$this->session && !$public)
                return false;
            if (isset($this->users_cache_id[$userid]))
                return $this->users_cache_id[$userid];

            $req = "SELECT * FROM `" . $this->config['db_prefix'] . "users` WHERE " . $this->db_where() . " `id`='" . addslashes($userid) . "'";
            $res = mysqli_query($this->mysqli, $req);
            if ($res && mysqli_num_rows($res) == 1) {
                $user = mysqli_fetch_object($res);
                $cache_key = $user->network.'/'.$user->name;
                $this->users_cache[$cache_key] = $user;
                $this->users_cache_id[$userid] = $user;
                return $user;
            }
            return false;
        }

        function is_valid_user($username, $network) {
            if (!$this->session)
                return false;
            if (false !== $user = $this->get_user($username, $network)) {
                return $user->status == 1;
            }
            return false;
        }

        function register_user($user, $network = '', $user_avatar = '', $user_description = '', $user_city = '', $external_id='') {
            if (!$this->session)
                return false;

            //echo $username.' / '.$network.' / '.$user_avatar."\n\n";
            if (is_array($user)) {
                $user_array = $user;
                $username = isset($user_array['username']) ? $user_array['username'] : '';
                $network = isset($user_array['network']) ? $user_array['network'] : '';
                $user_avatar = isset($user_array['user_avatar']) ? $user_array['user_avatar'] : '';
                $user_description = isset($user_array['user_description']) ? $user_array['user_description'] : '';
                $user_city = isset($user_array['user_city']) ? $user_array['user_city'] : '';
                $external_id = isset($user_array['external_id']) ? $user_array['external_id'] : '';
                $id = (isset($user_array['id']) && is_numeric($user_array['id'])) ? $user_array['id'] : NULL;
            }
            else{
              $username = $user;
            }
            $username = strip_tags($username);
            if (!empty($username) && !empty($network)) {

                if($id !== NULL){
                  $req = "UPDATE
          `" . $this->config['db_prefix'] . "users` SET
            `name` = '" . addslashes($username) . "',
            `external_id` = '" . addslashes($external_id) . "',
            `avatar_url` = '" . addslashes($user_avatar) . "',
            `user_description` = '" . addslashes($user_description) . "',
            `user_city` = '" . addslashes($user_city) . "'
            WHERE `id`=$id";
                  if (mysqli_query($this->mysqli, $req)) {
                      return $this->get_user($username, $network);
                  }
                }
                $cache_key = $network.'/'.$username;
                if (isset($this->users_cache[$cache_key]))
                    return $this->users_cache[$cache_key];
                $req = "INSERT INTO
				`" . $this->config['db_prefix'] . "users`
				(`session_id`,`name`,`external_id`,`network`,`avatar_url`,`user_description`,`user_city`,`status`)
			VALUES
				('" . $this->session->id . "','" . addslashes($username) . "','" . addslashes($external_id) . "','" . addslashes($network) . "','" . addslashes($user_avatar) . "','" . addslashes($user_description) . "','" . addslashes($user_city) . "',1) ";
                if (mysqli_query($this->mysqli, $req)) {
                    return $this->get_user($username, $network);
                }
            }
            return false;
        }

        function list_users($param = array(), $decoration=false) {
            if (!$this->session)
                return false;
            if (!is_array($param)) {
                $param = array();
            }
            $default = array(
                'network' => '',
                'status' => '',
                'minid' => '',
                'maxid' => '',
                'order' => 'DESC',
                'order_by' => 'id',
                'per_page' => '5',
                'page' => '1'
            );

            foreach ($default as $k => $v) {
                if (isset($param[$k])) {
                    $param[$k] = $this->mysqli->real_escape_string($param[$k]);
                }
                else {
                    $param[$k] = $default[$k];
                }
            }

            $req = "SELECT * FROM `" . $this->config['db_prefix'] . "users` WHERE " . $this->db_where() . " 1 ";
            if (!empty($param['user_id'])) {
                $req.=" AND `id`='" . $param['item_id'] . "'";
            }
            else {
                if (!empty($param['network'])) {
                    $req.=" AND `network`='" . $param['network'] . "'";
                }
                if (!empty($param['status'])) {
                    $req.=" AND `status`='" . $param['status'] . "'";
                }

                if (!empty($param['minid'])) {
                    $req.=" AND `id`>'" . $param['minid'] . "'";
                }
                if (!empty($param['maxid'])) {
                    $req.=" AND `id`<'" . $param['maxid'] . "'";
                }

                if (!empty($param['order']) && !empty($param['order_by'])) {
                    $req.=" ORDER BY `" . $param['order_by'] . "`" . ($param['order'] == 'DESC' ? 'DESC' : 'ASC');
                }

                if (is_numeric($param['per_page']) && is_numeric($param['page']) && $param['per_page'] > 0 && $param['page'] > 0) {
                    $req.=" LIMIT " . (($param['page'] - 1) * $param['per_page']) . "," . $param['per_page'];
                }
            }
            $ret = array();
            if ($res = mysqli_query($this->mysqli, $req)) {
                while ($user = mysqli_fetch_object($res)) {
                    if($decoration){
                        $user = $this->decorate_user($user);
                    }
                    $ret[] = $user;
                }
            }
            return $ret;
        }

        /** Posts * */

        /**
         *
         * @global type $conn
         * @param array $params
         * @return boolean|string
         */
        function add($params) {
            $default = array(
                'text' => '',
                'username' => '',
                'network' => '',
                'pub_id' => '',
                'url' => '',
                'date' => '',
                'media_url' => '',
                'media_type' => '',
                'expanded_url' => '',
                'pub_lat' => '',
                'pub_lon' => '',
                'pub_ref' => '',
                'pub_reply_to' => '',
                'user_avatar' => '',
                'user_description' => '',
                'user_city' => '',
                'search' => '',
                'user_external_id' => '',
            );

            $params = parse_params($default, $params);
            extract($params);

            //echo'-';
            if (empty($username) || empty($network)){
                SYN()->log('Empty username or network', 'Item');
                return false;
            }
            if (!$this->session){
                SYN()->log('Empty session', 'Item');
                return false;
            }
            $text = strip_tags($text);
            //echo($text);
            if ((!empty($text) || !empty($media_url) || $this->session->empty == 1 ) && !empty($username) && !empty($network) && !empty($pub_id)) {
                global $conn;
                if (false !== $user = $this->get_user(array(
                    'username' => $username,
                    'network' => $network,
                    'user_avatar' => $user_avatar,
                    'user_description' => $user_description,
                    'user_city' => $user_city,
                    'external_id' => $user_external_id,
                        ))) {
                    $req = "SELECT
						`content`
					FROM
						`" . $this->config['db_prefix'] . "items`
					WHERE
						" . $this->db_where() . "
						`content`='" . addslashes($text) . "'
						AND `media_url`='" . addslashes($media_url) . "'
						 ";
                    if (isset($_GET['debug'])) {
                        debug($params, 1, 1);
                        debug($req, 1, 1);
                    }
                    $res = mysqli_query($this->mysqli, $req);
                    if ($this->session->duplicate === 0 && ($res != false && mysqli_num_rows($res) > 0)) {
                        return false;
                    }
                    $req = "INSERT INTO `" . $this->config['db_prefix'] . "items`
						(`session_id`,`user_id`, `network`, `pub_date`, `pub_url`,`pub_id`, `pub_lat`, `pub_lon`, `pub_ref`, `pub_reply_to`, `content`, `media_url`, `media_type`, `expanded_url`, `status`,`search`)
					VALUES (
						'" . $this->session->id . "',
						'" . $user->id . "',
						'" . addslashes($network) . "',
						'" . (!empty($date) ? date('Y-m-d H:i:s', strtotime($date)) : date('Y-m-d H:i:s', time())) . "',
						'" . addslashes($url) . "',
						'" . addslashes($pub_id) . "',
						'" . addslashes($pub_lat) . "',
						'" . addslashes($pub_lon) . "',
						'" . addslashes($pub_ref) . "',
						'" . addslashes($pub_reply_to) . "',
						'" . addslashes($text) . "',
						'" . addslashes($media_url) . "',
						'" . addslashes($media_type) . "',
						'" . addslashes($expanded_url) . "',
						'" . ($this->session->mod <= $user->status ? 1 : 0) . "',
						'" . addslashes($search) . "'
						) ";

                    //echo $req;
                    if (mysqli_query($this->mysqli, $req)) {
                        $inserted_id = mysqli_insert_id($conn);
                        $this->set_update_date_session($this->session->id);
                        return $inserted_id;
                    }
                    if($this->debug){
                        echo mysqli_error($conn);
                    }
                    $error = mysqli_error($conn);
                    SYN()->log($error, 'Item');
                    return $error;
                }
                SYN()->log("User «{$username}» not found", 'User');
                return false;
            }
            return 'missing values';
        }

        function decorate_user($user){
            $user->avatar_url = $this->full_base_url.$this->session->name.'/user/'.$user->id.'.png';
            return $user;
        }
        function decorate_item($item){
            if($item->media_url){
                $item->media_url = $this->full_base_url.$this->session->name.'/item/'.$item->id.'.png';
            }
            $item->decorated = true;
            $item->user = $this->decorate_user($item->user);
            return $item;
        }

        function get($param = array(), $decoration = false) {
            if (!$this->session)
                return false;
            if (!is_array($param)) {
                $param = array();
            }
            $default = array(
                // Filtering
                'network' => '',
                'username' => '',
                'status' => '1',
                'after' => '',
                'before' => '',
                'geo' => '',
                'minid' => '',
                'maxid' => '',
                'pub_id' => '',
                'item_id' => '',
                'ref' => '',
                'reply' => '',
                'search' => '',
                // Ordering
                'order' => 'DESC',
                'order_by' => 'pub_date',
                'per_page' => '5',
                'page' => '1',
                'offset' => '',
                'i' => ''
            );

            $param = parse_params($default, $param);

            // return $this->Item()->get($param);

            $req = "SELECT * FROM `" . $this->config['db_prefix'] . "items` WHERE " . $this->db_where() . " 1 ";
            if (!empty($param['item_id'])) {
                $req.=" AND `id`='" . $param['item_id'] . "'";
            }
            else {
                if (!empty($param['network'])) {
                    $req.=" AND `network`='" . $param['network'] . "'";
                }
                if (!empty($param['username']) && !empty($param['network'])) {
                    if (false !== $user = $this->get_user($param['username'], $param['network'])) {
                        $req.=" AND `user_id`='" . $user->id . "'";
                    }
                }
                if (!empty($param['status'])) {
                    $req.=" AND `status`>='" . $param['status'] . "'";
                }

                if (!empty($param['after'])) {
                    $req.=" AND `pub_date`>='" . date('Y-m-d H:i:s', strtotime($param['after'])) . "'";
                }
                if (!empty($param['before'])) {
                    $req.=" AND `pub_date`<='" . date('Y-m-d H:i:s', strtotime($param['before'])) . "'";
                }
                if (!empty($param['pub_id'])) {
                    $req.=" AND `pub_id`='" . $param['pub_id'] . "'";
                }

                if (!empty($param['minid'])) {
                    $req.=" AND `id`>'" . $param['minid'] . "'";
                }
                if (!empty($param['maxid'])) {
                    $req.=" AND `id`<'" . $param['maxid'] . "'";
                }
                if ('' != $param['geo']) {
                    $comparator = $param['geo'] ? '!=' : '=';
                    $req.=" AND `pub_lat`" . $comparator . "'' AND `pub_lon`" . $comparator . "''";
                }

                if ('yes' == $param['ref']) {
                    $req.=" AND `pub_ref`!=''";
                }
                elseif ('no' == $param['ref']) {
                    $req.=" AND `pub_ref`=''";
                }
                elseif (is_numeric($param['ref'])) {
                    $req.=" AND `pub_ref`=" . $param['ref'] . "";
                }

                if ('yes' == $param['reply']) {
                    $req.=" AND `pub_reply_to`!=''";
                }
                elseif ('no' == $param['reply']) {
                    $req.=" AND `pub_reply_to`=''";
                }
                elseif (is_numeric($param['reply'])) {
                    $req.=" AND `pub_reply_to`=" . $param['reply'] . "";
                }

                if (!empty($param['search'])) {
                    $searches = explode('|', $param['search']);
                    $req.="AND (";
                    foreach ($searches as $search) {
                        $req.=" `content`LIKE'%" . trim($search) . "%' OR";
                    }
                    $req = substr($req, 0, -3);
                    $req.=")";
                }

                if (!empty($param['order']) && !empty($param['order_by'])) {
                    $req.=" ORDER BY `" . $param['order_by'] . "`" . ($param['order'] == 'DESC' ? 'DESC' : 'ASC');
                }
                if (is_numeric($param['i'])) {
                    $req.=" LIMIT " . $param['i'] . ",1";
                }
                elseif (is_numeric($param['per_page']) && is_numeric($param['offset']) && $param['per_page'] > 0 && $param['offset'] > 0) {
                    $req.=" LIMIT " . $param['offset'] . "," . $param['per_page'];
                }
                elseif (is_numeric($param['per_page']) && is_numeric($param['page']) && $param['per_page'] > 0 && $param['page'] > 0) {
                    $req.=" LIMIT " . (($param['page'] - 1) * $param['per_page']) . "," . $param['per_page'];
                }
            }
            if ($this->debug) {
                debug($param, 1, 1);
                debug($req, 1, 1);
            }
            //echo $req;
            $ret = array();
            if (false !== $res = mysqli_query($this->mysqli, $req)) {
                while ($item = mysqli_fetch_object($res)) {
                    if ($item->pub_ref != '' && $this->session->advanced_repost && !is_numeric($param['pub_id'])) {
                        $ref_item = $this->get(array(
                            'network' => $item->network,
                            'pub_id' => str_replace('>', '', $item->pub_ref),
                            'status' => -1
                        ));
                        //$item->content = '(RT*) '.$item->content;
                        if (count($ref_item)) {
                            if(substr($item->pub_ref, 0, 1)=='>'){
                                $item->quoted_post = $ref_item[0];
                                $item->pub_ref = substr($item->pub_ref, 1);
                            }
                            else{
                                $item->reposter = $this->get_user_by_id($item->user_id);
                                $item->content = $ref_item[0]->content; //.' (RT by '.$item->repost_by->name.') ';
                                $item->user_id = $ref_item[0]->user_id;
                            }
                        }
                    }
                    if ($item->pub_reply_to != '') {
                        $rep_item = $this->get(array(
                            'network' => $item->network,
                            'pub_id' => $item->pub_reply_to,
                            'status' => -1
                        ));
                        //$item->content = '(RT*) '.$item->content;
                        if (count($rep_item)) {
                            $item->replied_post = $rep_item[0];
                        }
                    }
                    // Instagram normalization
                    if($item->media_type === 'sidecar'){
                      $item->media_type = 'image';
                    }

                    if (!json_encode($item->content)) {
                        $item->content = utf8_encode($item->content);
                    }
                    $item->user = $this->get_user_by_id($item->user_id);
                    $item->timestamp = strtotime($item->pub_date);
                    if($decoration){
                        $item = $this->decorate_item($item);
                    }
                    $ret[] = $item;
                }
            }
            return $ret;
        }

        function get_video_url($item){
            //test si le media est video, test si le media type est nul
            if ($item->network == "instagram"){
                //curl sur l'expendid_urlregarder le code de retour si 200 retun expendid elif utiliser jeton our re recuperer le endpoint de l'item_id du post et l'ecire dans la base de donnée.
            }
        }

        function mention_detect($content, $network) {
            $content = str_replace('@', ' @', $content);
            preg_match_all('#[\n\t\r\s  \: \.]@([a-zA-Z0-9_]+)[\n\t\r\s\:\.\/,  \?; ]#i', ' ' . $content . ' ', $array, PREG_PATTERN_ORDER);
            if (is_array($array)) {
                foreach ($array[1] as $mention) {
                    $html = ' <span class="mention">';
                    if (false !== $user = $this->get_user($mention, $network)) {
                        if (!empty($user->avatar_url)) {
                            $html.='<img src="' . $user->avatar_url . '">';
                        }
                    }
                    $html.=' @' . $mention . '</span>';
                    $content = str_replace('@' . $mention, $html, $content);
                }
            }
            return $content;
        }

        function hashtag_detect($content) {
            $content = str_replace('#', ' #', $content);
            preg_match_all('#[\n\t\r\s  \: \.]\#([a-zA-Z0-9_]+)[\n\t\r\s\:\.\/,  \?; ]#i', ' ' . $content . ' ', $array, PREG_PATTERN_ORDER);
            if (is_array($array)) {
                foreach ($array[1] as $hastag) {
                    $html = ' <span class="hashtag">';
                    $html.='#' . $hastag . '</span>';
                    $content = str_replace('#' . $hastag, $html, $content);
                }
            }
            return $content;
        }

        function url_detect($content) {
            $content = str_replace('http', ' http', $content);
            preg_match_all('#[\n\t\r\s\: ]https?://([a-zA-Z0-9_\?\&\-\/\.\:]+)[\n\t\r\s ]#i', ' ' . $content . ' ', $array, PREG_PATTERN_ORDER);
            if (is_array($array)) {
                foreach ($array[1] as $url) {
                    $html = ' <span class="url">';
                    $html.='' . $url . '</span>';
                    $content = str_replace(array('http://' . $url, 'https://' . $url), $html, $content);
                }
            }
            return $content;
        }

        /** Moderation * */
        function moderate_item($item_id, $mod = 0) {
            if (!$this->session)
                return false;
            $req = "UPDATE `" . $this->config['db_prefix'] . "items` SET `status`='" . $mod . "' WHERE " . $this->db_where() . " `id`='" . $item_id . "'";
            if (mysqli_query($this->mysqli, $req)) {
                return true;
            }
            return false;
        }

        function moderate_user($user_id, $mod = 0, $recursive = 0) {
            if (!$this->session)
                return false;
            $req = "UPDATE `" . $this->config['db_prefix'] . "users` SET `status`='" . $mod . "' WHERE " . $this->db_where() . " `id`='" . $user_id . "'";
            if ($recursive == 1 && ($mod == 0 || $mod == 2)) {
                if (mysqli_query($this->mysqli, $req)) {
                    $req = "UPDATE `" . $this->config['db_prefix'] . "items` SET `status`='" . $mod . "' WHERE " . $this->db_where() . " `user_id`='" . $user_id . "'";
                    if (mysqli_query($this->mysqli, $req)) {
                        return true;
                    }
                    echo'bof... ' . $req;
                }
                return false;
            }
            if (mysqli_query($this->mysqli, $req)) {
                return true;
            }
            return true;
        }

        /** Deletion * */
        function del_item($item_id) {
            if (!$this->session)
                return false;
            $req = "DELETE FROM `" . $this->config['db_prefix'] . "items` WHERE " . $this->db_where() . " `id`='" . $item_id . "'";
            if (mysqli_query($this->mysqli, $req)) {
                return true;
            }
            return false;
        }

        function del_user($user_id, $recursive = 0) {
            if (!$this->session)
                return false;
            $req = "DELETE FROM `" . $this->config['db_prefix'] . "users` WHERE " . $this->db_where() . " `id`='" . $user_id . "'";
            if ($recursive == 1) {
                if (mysqli_query($this->mysqli, $req)) {
                    $req = "DELETE FROM `" . $this->config['db_prefix'] . "items` WHERE " . $this->db_where() . " `user_id`='" . $user_id . "'";
                    if (mysqli_query($this->mysqli, $req)) {
                        return true;
                    }
                    echo'bof... ' . $req;
                }
                return false;
            }
            if (mysqli_query($this->mysqli, $req)) {
                return true;
            }
            return true;
        }

        /**
         * If called from front :
         * make template
         */
        function front() {
            $current_path = substr($this->current_path, strlen($this->config['base_path']));
            if (empty($current_path)) {
            }
            else{
                $vars = explode('/', $current_path . '/');
                $name = isset($vars[0]) ? str_replace('.rss', '', $vars[0]) : '';
                $req = "SELECT * FROM `" . $this->config['db_prefix'] . "sessions` WHERE `name`='" . addslashes($name) . "' ";
                if (false !== ($res = mysqli_query($this->mysqli, $req)) && mysqli_num_rows($res) == 1) {
                    $row = mysqli_fetch_object($res);
                    $_SESSION['session'] = $row;
                    $this->session = $row;
                    $this->title = $row->name . ' : ' . $this->title;
                    $this->template = isset($vars[1]) && in_array($vars[1], $this->templates) ? $vars[1] : 'slide';
                }
            }
        }

        /**
         * get rotate
         */
        function rotate() {
            $rotate = 0;
            $this->session = $_SESSION['session'];
            if ($this->session) {
                $req = "SELECT COUNT(`id`) FROM `" . $this->config['db_prefix'] . "items` WHERE `session_id`='" . $this->session->id . "' AND `status`=1";
                if (false !== ($res = mysqli_query($this->mysqli, $req)) && mysqli_num_rows($res) == 1) {
                    $row = mysqli_fetch_array($res);
                    $rotate = $row[0] >= 10 ? 10 : $row[0] - 1;
                }
            }

            if (!isset($_SESSION['eg_i'])) {
                $_SESSION['eg_i'] = $rotate;
            }
            else {
                $_SESSION['eg_i'] --;
                if ($_SESSION['eg_i'] < 0) {
                    $_SESSION['eg_i'] = $rotate;
                }
            }
        }

        function styles() {
            ?>
            <link rel="stylesheet" href="<?php echo $this->base_url; ?>vendor/twbs/bootstrap/dist/css/bootstrap.min.css" />
            <link rel="stylesheet" href="<?php echo $this->base_url; ?>css/base.css" />
            <?php if(!strstr($this->current_path, '/pages/') && $this->template!='main'): ?>
            <link rel="stylesheet" href="<?php echo $this->base_url; ?>css/ecologram.css" />
            <?php endif; ?>
            <link href='//fonts.googleapis.com/css?family=Roboto:100,300,500,700,900,400|Roboto+Slab:400,100,700,300|Roboto+Condensed:400,700,300' rel='stylesheet' type='text/css'>
            <?php
        }

        function scripts() {
            ?>
            <script src="<?php echo $this->base_url; ?>vendor/components/jquery/jquery.min.js"></script>
            <script type="text/javascript">var eg = {base_path: '<?= $this->config['base_path'] ?>', refresh_delay: '<?= $this->config['refresh_delay'] ?>'};</script>
            <?php if ($this->template != 'main'): ?>
                <script src="<?php echo $this->base_url; ?>js/ecologram.js"></script>
                <?php
            endif;
        }

        function su_scripts() {
            ?>
            <?php $this->scripts();?>
            <script src="<?php echo $this->base_url; ?>vendor/components/jqueryui/jquery-ui.min.js"></script>
            <script src="<?php echo $this->base_url; ?>js/su.js"></script>
            <link rel="stylesheet" href="<?php echo $this->base_url; ?>vendor/twbs/bootstrap/dist/css/bootstrap.css">
            <link rel="stylesheet" href="<?php echo $this->base_url; ?>css/su.css">
            <script src="<?php echo $this->base_url; ?>vendor/twbs/bootstrap/dist/js/bootstrap.js"></script>
            <?php
        }

        function su_css() {
            ?>
            <link rel="stylesheet" href="<?php echo $this->base_url; ?>vendor/twbs/bootstrap/dist/css/bootstrap.css">
            <?php
        }

        function admin_scripts() {
            $eg_admin = array(
                'session' => $this->session,
                'net' => $this->networks,
                'server' => array(
                    'name' => $this->server_name,
                    'protocol' => $this->server_protocol
                ),
                'strings' => array(
                    'User details' => utf8_encode(__('User details'))
                ),
                'use_subdomains' => $this->config['use_subdomains']
                    )
            ?>

            <script type="text/javascript">
                var eg_admin = <?php echo json_encode($eg_admin) ?>;
                var current_page = 'admin';
            </script>
            <?php $this->scripts(); ?>
            <script src="<?php echo $this->base_url; ?>vendor/components/jqueryui/jquery-ui.min.js"></script>
            <script src="//cdn.rawgit.com/noelboss/featherlight/master/release/featherlight.min.js" type="text/javascript" charset="utf-8"></script>
            <script src="<?php echo $this->base_url; ?>js/php.js"></script>
            <script src="<?php echo $this->base_url; ?>js/ecologram-admin.js"></script>
            <?php
            if (basename($_SERVER['SCRIPT_NAME']) == 'index.php' || basename($_SERVER['SCRIPT_NAME']) == 'networks.php') {
                foreach ($this->networks as $network => $attr) {
                    if (is_file($this->networks_path . $network . '/' . $network . '.js')) {
                        ?>
                        <script src="<?= $this->config['base_path'] . 'includes/networks/' . $network . '/' . $network ?>.js"></script>
                        <?php
                    }
                }
            }
        }

        function template($include=null) {
            if(!$include){
                $include = $this->template;
            }
            $include = ABS_PATH . 'templates/' . $include. '.php';
            if (file_exists($include)) {
                include($include);
            }
        }

        function stream_headers() {
            include_once 'includes/stream_headers.php';
        }

        function delete_cache($key) {
          $req = "DELETE FROM `" . $this->config['db_prefix'] . "cache` WHERE " . $this->db_where() . " `key`='" . $key . "'";
          return mysqli_query($this->mysqli, $req);
        }
        function get_cache($key) {
            $req = "SELECT * FROM `" . $this->config['db_prefix'] . "cache` WHERE " . $this->db_where() . " `key`='" . $key . "'";
            if (false !== ($res = mysqli_query($this->mysqli, $req))) {
                $object = mysqli_fetch_object($res);
                if (!$object) {
                    return false;
                }
                if(strtotime($object->expire)<time()){
                    $this->delete_cache($key);
                    return false;
                }
                if (false !== $maybe_json = json_decode($object->value)) {
                    return $maybe_json;
                }
                return $object->value;
            }
            return false;
        }

        function set_cache($key, $value, $expire = 3600) {
            $expire_date = date('Y-m-d H:i:s', time() + $expire);
            if (is_object($value) || is_array($value)) {
                $value = json_encode($value);
            }
            $req = "DELETE FROM `" . $this->config['db_prefix'] . "cache` WHERE " . $this->db_where() . " `key`='" . $key . "'";
            if (false !== ($res = mysqli_query($this->mysqli, $req))) {
                $req = "INSERT INTO`" . $this->config['db_prefix'] . "cache` (`session_id`,`key`,`value`,`expire`) VALUES ('" . $this->session->id . "','" . addslashes($key) . "','" . addslashes($value) . "','" . $expire_date . "')";
                if(mysqli_query($this->mysqli, $req)){
                  return true;
                }
            }
            global $conn;
            debug($req, 1, 1);
            debug(mysqli_error($conn), 1, 1);
            return false;
        }

        function add_script($name, $text) {
            $this->scripts[$name] = $text;
        }

        function add_ajax_script($name, $text) {
            $this->ajax_scripts[$name] = $text;
        }

        function add_jquery_script($name, $text) {
            $this->add_script($name, '<script>$(document).ready(function(){ '.$text.' });</script>');
            $this->add_ajax_script($name, '<script>'.$text.'</script>');
        }

        function print_scripts() {
            foreach ($this->scripts as $name => $text) {
                echo $text;
            }
        }

        function print_ajax_scripts() {
            foreach ($this->ajax_scripts as $name => $text) {
                echo $text;
            }
        }

        function set_update_date_session($session_id){
          $req = "UPDATE `" . $this->config['db_prefix'] . "sessions`
                  SET `date_updated`=NOW()
                  WHERE `id`='" . $session_id . "'";
          return mysqli_query($this->mysqli, $req);
        }

        function set_fetch_date_session($session_id){
          $req = "UPDATE `" . $this->config['db_prefix'] . "sessions`
                  SET `date_fetched`=NOW()
                  WHERE `id`='" . $session_id . "'";
          return mysqli_query($this->mysqli, $req);
        }

        function update_syn_sessions($session_name, $date_begin, $date_end, $id){
            $req = "UPDATE ". $this->config['db_prefix'] . "sessions
                    SET
                    name = '" . $session_name ."',
                    date_begin = " . (($date_begin && $date_begin != "") ? "'" . $date_begin . "'" : "NULL") . ",
                    date_end = " . (($date_end && $date_end != "") ? "'" . $date_end . "'" : "NULL") . "
                    WHERE
                    id = " . $id;
            return mysqli_query($this->mysqli, $req);
        }

        function delete_syn_sessions($id){
            $req = "DELETE FROM " . $this->config['db_prefix'] ."items WHERE session_id = " . $id;
            mysqli_query($this->mysqli, $req);
            $req = "DELETE FROM " . $this->config['db_prefix'] ."networks WHERE session_id = " . $id;
            mysqli_query($this->mysqli, $req);
            $req = "DELETE FROM " . $this->config['db_prefix'] ."users WHERE session_id = " . $id;
            mysqli_query($this->mysqli, $req);
            $req = "DELETE FROM " . $this->config['db_prefix'] ."sessions WHERE id = " . $id;
            mysqli_query($this->mysqli, $req);
            return ;
        }

        function login_su($user, $pwd){
          if ($this->suUsername == false || $this->suPassword == false)
            return (false);
          if ($this->suUsername != $user || $this->suPassword != $pwd)
            return (false);
          else {
            $_SESSION['su'] = TRUE;
            return (true);
          }
        }

        function add_data($api, $token, $apiObject = ""){
          $data[] = ["api" => $api, "token" => $token, "apiObject" => $apiObject, "date" => " "];

          // $inp = file_get_contents('results.json');
          // $tempArray = json_decode($inp);
          // array_push($tempArray, $data);
          // $jsonData = json_encode($tempArray);
          // file_put_contents('results.json', $jsonData);
        }

        public function addCallFromApi($token){
          $req = "SELECT id FROM " . $this->config['db_prefix'] ."sessions WHERE token = '" . $token . "'";
          $results = mysqli_query($this->mysqli, $req);
          foreach ($results as $row) {
            $id = $row['id'];
          }
          $req = "INSERT INTO " . $this->config['db_prefix'] ."api_call (id_session, date) VALUES (". $id . ",'". date('Y-m-d H:i:s') ."')";
          mysqli_query($this->mysqli, $req);
        }

        public function log($str, $group=""){
            $msg_type = 0;
            $msg_dest = '?';
            if(isset($this->config['log_file']) && $this->config['log_file']){
                $msg_type = 3;
                $msg_dest = $this->config['log_file'];
            }
            $log = [
                date('r'),
                'SlideYourNet'.($group ? '-'.$group : ''),
                'session#'.($this->session ? $this->session->id : 0),
                is_string($str) ? $str : json_encode($str),
            ];
            $msg = implode("\t", $log)."\n";
            if($this->debug && CLI){
                echo $msg;
            }
            error_log ($msg, $msg_type, $msg_dest);
        }

    }
    global $eg;
    $eg = new ecologram();

    function SYN(){
        global $eg;
        return $eg;
    }
}
