<?php
global $SYNFacebook;
$SYNFacebook = new SYNFacebook();

class SYNFacebook {

    /**
     * Facebook instance
     * @var Facebook\Facebook
     */
    var $fb;

    /**
     * FacebookApp instance
     * @var Facebook\FacebookApp
     */
    var $fbApp;

    /**
     * Facebook RedirectLoginHelper
     * @var RedirectLoginHelper
     */
    var $fbHelper;

    /**
     * Array of permission required by the app
     * @var array
     */
    var $fbPermissions;

    /**
     * Facebook session
     * @var type
     */
    var $fbAccessToken;

    /**
     * paired profile
     * @var array
     */
    var $profile;

    var $class = 'Facebook';

    function __construct() {
        /*
        add_action('init', array(&$this, 'init'), 6);
        add_action('admin_notices', array(&$this, 'notices'));

        add_filter('commonsco_default_config', array(&$this, 'alter_default_config'), 1);
        add_action('commonsco_config_form', array(&$this, 'alter_config_form'), 1);
        add_filter('commonsco_saved_config', array(&$this, 'alter_saved_config'), 1);

        add_action( 'admin_post_commonsco_fb_login', array( &$this, 'login' ) );

        add_action( 'admin_post_nopriv_commonsco_fbtab', array( &$this, 'tab' ) );
        add_action( 'admin_post_commonsco_fbtab', array( &$this, 'tab' ) );*/

        $this->fbPermissions = ['email',  'pages_read_engagement', 'instagram_basic'];
        $this->fb = false;
        $this->fbApp = false;
        $this->fbAccessToken = false;
        $this->profile = false;

        $this->init();
    }

    // PHP 4 loader
    function SYNFacebook() {
        $this->__construct();
    }

    /**
     * Save Facebook's access token to global config
     * @param string $access_token
     */
    function save_access_token($access_token){
        if(SYN()->networks['facebook']['options']['access_token'] != $access_token){
            SYN()->networks['facebook']['options']['access_token'] = $access_token;

            //update_option('commonsco_config', SYN()->config);
            $options = serialize(SYN()->networks['facebook']['options']);
            $req = "UPDATE `" . SYN()->config['db_prefix'] . "networks` SET `status`='1', `preferences`='" . $options . "' WHERE " . SYN()->db_where() . " `name`='facebook'";
            return mysqli_query(SYN()->mysqli, $req);
        }
    }

    function update_settings(){
        if(!$this->fbAccessToken || !isset($_POST)){
            return;
        }
        $old_target_id = isset(SYN()->networks_old['facebook']['options']['target_id']) ? SYN()->networks_old['facebook']['options']['target_id'] : null;
        $new_target_id = $_POST['networks']['facebook']['target_id'];

        if($old_target_id != $new_target_id){
          // TODO: something
        }
    }

    /**
     * Try to retreive the access token
     * @global \CommonsCo $eg
     * @return string
     */
    function init(){
        if(!SYN()->config['facebook']['app_id'] || !SYN()->config['facebook']['app_secret']){
            return;
        }

        $this->fb = new Facebook\Facebook(array(
            'app_id' => SYN()->config['facebook']['app_id'],
            'app_secret' => SYN()->config['facebook']['app_secret'],
            'default_graph_version' => 'v12.0'
        ));
        $this->fbApp = $this->fb->getApp();

        $this->fbHelper = $this->fb->getRedirectLoginHelper();

        $accessToken = !empty(SYN()->networks['facebook']['options']['access_token']) ? SYN()->networks['facebook']['options']['access_token'] : false;

        if($accessToken){
            $this->fbAccessToken = $accessToken;
            try {
                $this->fb->setDefaultAccessToken($accessToken);
                $profile_request = $this->fb->get('/me?fields=name');
                $this->profile = $profile_request->getGraphNode()->asArray();
            }catch (Facebook\Exceptions\FacebookResponseException $e) {
                $this->fbAccessToken='';
                SYN()->networks['facebook']['options']['access_token']='';
                $req = "UPDATE `" . SYN()->config['db_prefix'] . "networks` SET `status`='" . SYN()->networks['facebook']['status'] . "', `preferences`='' WHERE " . SYN()->db_where() . " `name`='facebook'";
                mysqli_query(SYN()->mysqli, $req);
                echo'<span class="alert alert-danger">'.__('Your facebook account has been disconnected').'</span>';
            }


        }
        else{
            $this->login();
        }

        if (isset($_POST['networks']['facebook'])) {
            $this->update_settings();
        }
    }

    /**
     * Returns the facebook login URL
     * @param string $redirect
     * @return string
     */
    function login_url_dist($redirect = false) {
        if (!$redirect) {
            $redirect = SYN()->admin_url . 'networks/?' . http_build_query(
                            array(
                                // 's' => SYN()->session->name,
                                // 't' => SYN()->session->token,
                                'action' => 'facebook_login',
                            )
            );
        }
        return $this->fbHelper->getLoginUrl($redirect, $this->fbPermissions);
    }

    function login_url(){
		SYN()->to_session();
        return SYN()->admin_url .'networks/?'.  http_build_query(array('action'=>'facebook_auth'));
    }

    /**
     *
     */
    function login(){
        if(!$this->fb){
            _e('Facebook is not initialized', 'commonsco');
            exit;
        }
        if (filter_input(INPUT_GET, 'action')=='facebook_auth') {
            if(!SYN()->networks['facebook']['id']){
                $req = "INSERT INTO `" . SYN()->config['db_prefix'] . "networks`  (`session_id`, `status`,  `name`, `preferences`) VALUES ('" . SYN()->session->id . "', '1', 'facebook', '')";
            }
            else{
                $req = "UPDATE `" . SYN()->config['db_prefix'] . "networks` SET `status`='1' WHERE " . SYN()->db_where() . " `name`='facebook'";
            }
			SYN()->to_session();
            ob_get_clean();
            mysqli_query(SYN()->mysqli, $req);
            header('location: '.$this->login_url_dist());
            exit;
        }

        if(filter_input(INPUT_GET, 'action') != 'facebook_login'){
            return;
        }

        // getting short-lived access token
        //$accessToken = $this->get_access_token();
        try {
            if(!$this->fbAccessToken){
				SYN()->to_session();
                $accessToken = $this->fbHelper->getAccessToken(
					SYN()->admin_url .'networks/?'.  http_build_query(
						array(
							'action'=>'facebook_login'
						)
					)
				);
            }
        } catch (Facebook\Exceptions\FacebookResponseException $e) {
            // When Graph returns an error
            echo 'Graph returned an error: ' . $e->getMessage();

            exit;
        } catch (Facebook\Exceptions\FacebookSDKException $e) {
            // When validation fails or other local issues
            echo 'Facebook SDK returned an error: ' . $e->getMessage();
            exit;
        }

        $confirm='facebook_login_unknown_error';


        if (!$this->fbAccessToken && isset($accessToken)) {

            // OAuth 2.0 client handler
            $oAuth2Client = $this->fb->getOAuth2Client();

            // Exchanges a short-lived access token for a long-lived one
            $this->fbAccessToken = (string) $oAuth2Client->getLongLivedAccessToken($accessToken);

            $this->save_access_token($this->fbAccessToken);

            // setting default access token to be used in script
            $this->fb->setDefaultAccessToken($this->fbAccessToken);

            $confirm='login_paired';

            // redirect the user back to the same page if it has "code" GET variable
            if (isset($_GET['fb_get_tokencode'])) {
                $confirm='login_paired_dist';
            }
        }
        else{
            $confirm='login_failed';
        }
        $redirect = SYN()->admin_url . 'auth.php?' . http_build_query(
                        array(
                            's' => SYN()->session->name,
                            't' => SYN()->session->token,
                            'confirm' => $confirm,
                        )
        );
        ob_get_clean();
        header('location: '.$redirect);
        exit;
    }

    function switch_to_page(){
        if(SYN()->networks['facebook']['options']['target_type']=='page' && !empty(SYN()->networks['facebook']['options']['page_access_token'])){
            SYN()->log("Switch to page ".SYN()->networks['facebook']['options']['target_id'], $this->class);
            $this->fbAccessToken = SYN()->networks['facebook']['options']['page_access_token'];
            $this->fb->setDefaultAccessToken($this->fbAccessToken);
        }
    }

    function get_profiles(){
        return array($this->profile);
    }

    function get($url, $params=[]){
        if(!$this->fbAccessToken){
            SYN()->log('No token or credentials', $this->class);
            return array();
        }
        try{
            $url = $url.'?'.(is_string($params) ? http_build_query(json_decode($params)) : http_build_query($params));
            SYN()->log($url, $this->class);
            $request = $this->fb->get($url);
            $body = $request->getDecodedBody();
            SYN()->log($body, $this->class);
            $result = isset($body['data']) ? $body['data'] : $body;
            return $result;
        }
        catch(Facebook\Exceptions\FacebookResponseException $e){
            SYN()->log('FacebookResponseException: '.json_decode($e->getRawResponse())->error->message, $this->class);
            return false;
        }
    }

    /**
     * Fetch the events where the current profile is admin
     * @return array
     */
    function get_events(){
        if(!$this->profile){
            return false;
        }
        $url = '/'.$this->profile['id'].'/events';
        $params = [
                'type'=>'created',
        ];
        return $this->get($url, $params);
    }
    /**
     * Fetch the pages where the current profile is admin
     * @return array
     */
    function get_groups(){
        if(!$this->profile){
            return false;
        }
        $url = '/'.$this->profile['id'].'/groups';
        return $this->get($url);
    }
    /**
     * Fetch the groups where the current profile is admin
     * @return array
     */
    function get_pages(){
        if(!$this->profile){
            return false;
        }
        $url = '/'.$this->profile['id'].'/accounts';
        return $this->get($url);
    }

    function get_feed($full=false){
        if(!SYN()->networks['facebook']['options']['target_id']){
            SYN()->log('No token or credentials', $this->class);
            return array();
        }
        $this->switch_to_page();
        $url = '/'.SYN()->networks['facebook']['options']['target_id'].'/posts';
        $params = [];
        if($full){
            $params = [
                'locale'=>SYN()->config['locale'],
                'fields'=>'id,message,story,created_time,picture,full_picture,permalink_url,parent_id',
            ];
        }
        $last_post = SYN()->get(array('network'=>'facebook', 'per_page'=>1, 'status'=>0));
        if(count($last_post)){
           $params['since'] = $last_post[0]->timestamp;
        }
        return $this->get($url, $params);
    }

}
