<?php

require_once ABS_PATH . 'includes/networks/facebook/auth.php';
require_once ABS_PATH . 'includes/networks/instagram/instaLegacy.php';


class SYNInstagram extends SYNFacebook {
    var $account_id;
    var $hashtag_id;
    var $class = 'Instagram';
    var $Legacy;

    function __construct() {
        parent::__construct();
        $this->account_id = SYN()->networks['instagram']['options']['account_id'];
        $this->hashtag_id = SYN()->networks['instagram']['options']['hashtag_id'];
        $this->Legacy = new InstaLegacy;
    }

    function get_accounts(){
        if(!$this->profile){
            return false;
        }
        $url = '/'.$this->profile['id'];
        $params = [
            'fields'=>'accounts{connected_instagram_account{name}}',
        ];
        $result = $this->get($url, $params);
        return (isset($result['accounts']['data'])) ? $result['accounts']['data'] : [];
    }

    function fetch(array $params=[]){
        $params = parse_params([
            'type'    => 'user',
            'query'     => '',
            'hashtag'    => $this->hashtag_id,
            'per_page'  => 10,
            'after'     => null,
        ], $params);

        if($params['type']=='tag'){
            return $this->get_hashtag_posts($params);
        }
        if($params['type']=='user' || $params['type']=='userfeed'){
            return $this->get_user_posts($params);
        }
    }

    function get_hashtag(string $query){
        $url = '/ig_hashtag_search';
        $params = [
            'user_id' => $this->account_id,
            'q'=>$query,
            'fields'=>'name,id',
        ];
        $result = $this->get($url, $params);
        return isset($result[0]) ? $result[0] : $result;
    }

    function get_hashtag_posts($args=[]){
        if(!$this->hashtag_id){
            SYN()->log('No hashtag set.', 'Instagram');
        }
        $args = parse_params([
            'hashtag'     => $this->hashtag_id,
            'per_page'  => 10,
            'after'     => null,
        ], $args);

        $hashtag_id = is_numeric($args['hashtag']) ? $args['hashtag'] : $this->get_hashtag($args['hashtag'])['id'];

        $url = "/{$hashtag_id}/recent_media";
        $params = [
            'user_id' => $this->account_id,
            'fields'=>'caption,media_type,media_url,permalink,timestamp',
            'limit'=>$args['per_page'],
            'after'=>$args['after'],
        ];

        $posts = $this->get($url, $params);
        if(!is_array($posts) || !isset($posts[0])){
            return false;
        }
        foreach($posts as $p=>$post){
            if(false != $username = $this->Legacy->get_username($post['permalink'])){
                $post['username'] = $username;
            }
            $posts[$p] = $post;
        }
        return $posts;
    }

    function get_user_posts($args=[]){
        if(!$this->account_id){
            SYN()->log('No account set.', 'Instagram');
        }
        $args = parse_params([
            'account'     => $this->account_id,
            'per_page'  => 10,
            'after'     => null,
        ], $args);

        $url = "/{$args['account']}/media";
        $params = [
            // 'user_id' => $this->account_id,
            'fields'=>'caption,media_type,media_url,permalink,timestamp',
            'limit'=>$args['per_page'],
            'after'=>$args['after'],
        ];

        return $this->get($url, $params);
    }

    function get_user_data($args=[]){
        if(!$this->account_id){
            SYN()->log('No account set.', 'Instagram');
        }
        $args = parse_params([
            'account'     => $this->account_id,
            'fields'  => null,
        ], $args);

        $url = "/{$args['account']}";
        $params = [
            'fields'=>$args['fields'],
        ];

        return $this->get($url, $params);
    }
}
