<?php

/**
 * Inspired by https://github.com/rarcega/instagram-scraper
 */
class InstaLegacy{
  var $can_use_user_info = true;

  private $BASE_URL;
  private $LOGIN_URL;
  private $LOGOUT_URL;
  private $CHROME_WIN_UA;
  private $USER_URL;
  private $USER_INFO;

  private $STORIES_URL;
  private $STORIES_UA;

  private $TAGS_URL;
  private $LOCATIONS_URL;
  private $VIEW_MEDIA_URL;
  private $SEARCH_URL;

  private $QUERY_FOLLOWINGS;
  private $QUERY_FOLLOWINGS_VARS;

  private $QUERY_COMMENTS;
  private $QUERY_COMMENTS_VARS;

  private $QUERY_HASHTAG;
  private $QUERY_HASHTAG_VARS;

  private $QUERY_LOCATION;
  private $QUERY_LOCATION_VARS;

  private $QUERY_MEDIA;
  private $QUERY_MEDIA_VARS;

  function __construct(){

    $this->BASE_URL = 'https://www.instagram.com/';
    $this->LOGIN_URL = $this->BASE_URL . 'accounts/login/ajax/';
    $this->LOGOUT_URL = $this->BASE_URL . 'accounts/logout/';
    $this->CHROME_WIN_UA = 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36';
    $this->USER_URL = $this->BASE_URL . '%s/?__a=1';
    $this->USER_INFO = 'https://i.instagram.com/api/v1/users/%s/info/';

    $this->STORIES_URL = $this->BASE_URL . 'graphql/query/?query_hash=45246d3fe16ccc6577e0bd297a5db1ab&variables=%7B%22reel_ids%22%3A%5B%22%s%22%5D%2C%22tag_names%22%3A%5B%5D%2C%22location_ids%22%3A%5B%5D%2C%22highlight_reel_ids%22%3A%5B%5D%2C%22precomposed_overlay%22%3Afalse%7D';
    $this->STORIES_UA = 'Instagram 52.0.0.8.83 (iPhone; CPU iPhone OS 11_4 like Mac OS X; en_US; en-US; scale=2.00; 750x1334) AppleWebKit/605.1.15';

    $this->TAGS_URL = $this->BASE_URL . 'explore/tags/%s/?__a=1';
    $this->LOCATIONS_URL = $this->BASE_URL . 'explore/locations/%s/?__a=1';
    $this->VIEW_MEDIA_URL = $this->BASE_URL . 'p/%s/?__a=1';
    $this->SEARCH_URL = $this->BASE_URL . 'web/search/topsearch/?context=blended&query=%s';

    $this->QUERY_FOLLOWINGS = $this->BASE_URL . 'graphql/query/?query_hash=c56ee0ae1f89cdbd1c89e2bc6b8f3d18&variables=%s';
    $this->QUERY_FOLLOWINGS_VARS = '{{"id":"%s","first":50,"after":"{1}"}}';

    $this->QUERY_COMMENTS = $this->BASE_URL . 'graphql/query/?query_hash=33ba35852cb50da46f5b5e889df7d159&variables=%s';
    $this->QUERY_COMMENTS_VARS = '{{"shortcode":"%s","first":50,"after":"{1}"}}';

    $this->QUERY_HASHTAG = $this->BASE_URL . 'graphql/query/?query_hash=ded47faa9a1aaded10161a2ff32abb6b&variables=%s';
    $this->QUERY_HASHTAG_VARS = '{{"tag_name":"%s","first":50,"after":"{1}"}}';

    $this->QUERY_LOCATION = $this->BASE_URL . 'graphql/query/?query_hash=ac38b90f0f3981c42092016a37c59bf7&variables=%s';
    $this->QUERY_LOCATION_VARS = '{{"id":"%s","first":50,"after":"{1}"}}';

    $this->QUERY_MEDIA = $this->BASE_URL . 'graphql/query/?query_hash=42323d64886122307be10013ad2dcc44&variables={"id":"%s","first":50}'; //,"after":"{1}"
  }

  function get_username($url){
      $username = $this->get_username_by_url($url);
      if(!$username){
          $p1 = strpos($url, 'com/');
          $url = substr_replace($url,"azer/",$p1+4,0);
          $ch = curl_init();
          curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
          curl_setopt($ch, CURLOPT_URL, $url);
          curl_setopt($ch, CURLOPT_HEADER, 1);
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
          curl_setopt($ch, CURLOPT_AUTOREFERER, 1);
          curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
          curl_setopt($ch, CURLOPT_MAXREDIRS, 5);
          curl_setopt($ch, CURLOPT_TIMEOUT, 30);
          curl_setopt($ch, CURLOPT_HEADER, true);
          curl_setopt($ch, CURLINFO_HEADER_OUT, 1);
          $url = curl_exec($ch);
          $username = $this->get_username_by_url(curl_getinfo($ch)['url']);
      }
      return $username;
  }

  function get_username_by_url($url){
      $p1 = strpos($url, 'com/');
      $url = substr($url, $p1+4);
      $p2 = strpos($url, '/p');
      $username = substr($url, 0, $p2);
      if($username){
          return $username;
      }
      return;
  }

  private function call_api($url){
      global $eg;
      $cache_key = 'instagram_api_call_'.sha1($url);
      if(false != $cached_result = $eg->get_cache($cache_key)){
          return $cached_result;
      }

      // Create a stream
      $headers = [
        'User-Agent'=>$this->STORIES_UA,
      ];
      array_walk($headers, function(&$v,$k){ $v = "$k:$v";});
      $opts = [
          "http" => [
              "method" => "GET",
              "header" => implode("\r\n", $headers),
          ],
      ];
      $context = stream_context_create($opts);
      debug(['Action'=>'API Call','url'=>$url,'ops'=>$opts], 3, 1);
      $json =  file_get_contents($url, false, $context);
      if($json && (null != $data = json_decode($json))){
          //debug($data, 3, 1);
          $eg->set_cache($cache_key, $data);
          return $data;
      }
      //debug($json, 3, 1);
      return false;
  }

  public function fetch($params = array()){
    global $eg;

    $default = array(
      'type'    => 'user',
      'query'     => '',
      'per_page'  => 10,
      'after'     => 0,
    );
    $param = parse_params($default, $params);

    if(empty($param['query'])){
      return false;
    }

    switch($param['type']){
      case 'user':
          // Check if user exists
          if((!isset($param['force']) || $param['force']==false) && is_numeric($param['query']) && (false != $maybe_user = $eg->get_user(array('external_id'=>$param['query'], 'network'=>'instagram')))){
            return $maybe_user;
          }
          // API limit is reached
          if(!$this->can_use_user_info){
              $user_array = $this->parse_user((object) array(
                'pk'=>$param['query'],
                'username'=>$this->get_username($param['permalink']),
                'profile_pic_url'=>'',
              ));
              debug($user_array, 3, 1);
              $eg->register_user($user_array);
              return $user_array;
          }

          // Fetch remote user
          // param is user's ID
          if(is_numeric($param['query'])){
            $data = $this->call_api(sprintf($this->USER_INFO, $param['query']));
          }
          else{
            $data = $this->call_api(sprintf($this->USER_URL, $param['query']));
          }
          if($data){
            $data_source = $data;
            if(isset($data->graphql)){
              $data_source = $data->graphql;
            }
            if(isset($data_source->user)){
              $user_array = $this->parse_user($data_source->user);
              $eg->register_user($user_array);
              return $user_array;
            }
          }
          $this->can_use_user_info = false;
          break;


      case 'tag':
          $url = sprintf($this->TAGS_URL, $param['query']);
          $eg->log($url, 'Instagram');
          $data = $this->call_api($url);
          $eg->log(json_encode($data), 'Instagram');
          if($data){
            if(isset($data->graphql->hashtag->edge_hashtag_to_media->edges)){
              $posts = array();
              foreach ($data->graphql->hashtag->edge_hashtag_to_media->edges as $row) {
                debug($row, 3, 1);
                $posts[] = $this->parse_tag_to_edge($row);
              }
              return $posts;
            }
          }
          break;

      case 'userfeed':
          $external_user_id = (false != $local_user = $eg->get_user(array('username'=>$param['query'], 'network'=>'instagram', 'no_create'=>true))) ? $local_user->external_id : false;
          // User is not yet registered
          if(!$external_user_id && (false != $user = $this->get(array('type'=>'user', 'query'=>$param['query'], 'force'=>true)))){
              $external_user_id = $user['external_id'];
          }

          if(!$external_user_id){
            return;
          }
          $url = sprintf($this->QUERY_MEDIA, $external_user_id);
          $eg->log($url, 'Instagram');
          $result = $this->call_api($url);
          $eg->log(json_encode($result), 'Instagram');
          if($result){
            if(isset($result->data->user->edge_owner_to_timeline_media->edges)){
              $posts = array();
              foreach ($result->data->user->edge_owner_to_timeline_media->edges as $row) {
                $posts[] = $this->parse_tag_to_edge($row);
              }
              return $posts;
            }
          }
          break;
    }
    return false;
  }
  private function parse_user($user){
    $main_id = isset($user->id) ? $user->id : null;
    return array(
      'external_id'       => isset($user->pk) ? $user->pk : $main_id,
      'name'              => $user->username,
      'username'          => $user->username,
      'full_name'         => isset($user->full_name) ? $user->full_name : '',
      'network'           => 'instagram',
      'avatar_url'        => $user->profile_pic_url,
      'user_avatar'       => $user->profile_pic_url,
      'user_description'  => isset($user->biography) ? $user->biography : '',
      'user_city'         => '',
    );
  }

  private function parse_tag_to_edge($row){
    $post_link = sprintf($this->VIEW_MEDIA_URL, $row->node->shortcode);
    $user = (array) $this->get(array('type'=>'user', 'query'=>$row->node->owner->id, 'permalink'=>$post_link));
    return array(
      'media_type'  => str_replace('graph', '', strtolower($row->node->__typename)),
      'owner'       => $user,
      'username'    => $user['name'],
      'id'          => $row->node->id,
      'caption'     => isset($row->node->edge_media_to_caption->edges[0]->node->text) ? $row->node->edge_media_to_caption->edges[0]->node->text : '',
      // 'location'    => false,
      'timestamp'   => $row->node->taken_at_timestamp,
      'permalink'   => $post_link,
      'media_url'   => $row->node->display_url,
    );
  }
}
