<?php

ini_set('display_errors', 1);

global $SYNTwitter;
$SYNTwitter = new SYNTwitter();


class SYNTwitter {

    var $instance;
    var $configured;
    var $connected;

    /**
     *
     * @var object
(
    [time_zone] => stdClass Object
        (
            [name] => Paris
            [utc_offset] => 3600
            [tzinfo_name] => Europe/Paris
        )

    [protected] =>
    [screen_name] => BastienHo
    [always_use_https] => 1
    [use_cookie_personalization] => 1
    [sleep_time] => stdClass Object
        (
            [enabled] =>
            [end_time] =>
            [start_time] =>
        )

    [geo_enabled] => 1
    [language] => fr
    [discoverable_by_email] => 1
    [discoverable_by_mobile_phone] => 1
    [display_sensitive_media] => 1
    [allow_contributor_request] => all
    [allow_dms_from] => following
    [allow_dm_groups_from] => following
    [translator_type] => none
    [trend_location] => Array
        (
            [0] => stdClass Object
                (
                    [name] => Toulouse
                    [countryCode] => FR
                    [url] => http://where.yahooapis.com/v1/place/628886
                    [woeid] => 628886
                    [placeType] => stdClass Object
                        (
                            [name] => Town
                            [code] => 7
                        )

                    [parentid] => 23424819
                    [country] => France
                )

        )

    [httpstatus] => 200
    [rate] => stdClass Object
        (
            [limit] => 15
            [remaining] => 11
            [reset] => 1484312356
        )

)
     */
    var $profile;

    function __construct() {
        global $eg;
        if(isset($eg->config['twitter']['consumer_key']) && isset($eg->config['twitter']['consumer_secret']) && $eg->config['twitter']['consumer_key'] && $eg->config['twitter']['consumer_secret']){
            $this->configured = true;
        }

        $this->profile = (object) array(
            'screen_name'=>__('Twitter is not configured'),
        );
        $this->init();
    }

    function init() {
        global $eg;
        if(!$this->configured){
            return;
        }

        \Codebird\Codebird::setConsumerKey($eg->config['twitter']['consumer_key'], $eg->config['twitter']['consumer_secret']); // static, see README

        $this->instance = \Codebird\Codebird::getInstance();

        if (!empty($eg->networks['twitter']['options']['token']) && !empty($eg->networks['twitter']['options']['secret'])) {
            $this->instance->setToken($eg->networks['twitter']['options']['token'], $eg->networks['twitter']['options']['secret']);
            $this->connected = true;
        }
        elseif (filter_input(INPUT_GET, 'action')=='twitter_auth') {
            $this->login();
        }

        // After this point, we need to be connected
        if(!$this->is_connected()){
            return;
        }
        if(false == $this->profile = $eg->get_cache('twitter_remote_profile')){
            $remote_profile = $this->instance->account_settings();
            if($remote_profile && !isset($remote_profile->errors)){
                $this->profile = $remote_profile;
                $eg->set_cache('twitter_remote_profile', $this->profile);
            }
            else{
                $this->connected = false;
                $eg->networks['twitter']['options']['token']='';
                $eg->networks['twitter']['options']['secret']='';
                $req = "UPDATE `" . $eg->config['db_prefix'] . "networks` SET `preferences`='".  addslashes(serialize($eg->networks['twitter']['options']))."' WHERE " . $eg->db_where() . " `name`='twitter'";
                mysqli_query($eg->mysqli, $req);
                echo'<span class="alert alert-danger">'.__('Your twitter account has been disconnected').'</span>';
            }
        }
    }

    function is_connected(){
        return $this->connected;
    }
    function exists(){
        return $this->configured;
    }

    function login_url(){
        global $eg;
        return $eg->admin_url .'networks.php?'.  http_build_query(array('s'=>$eg->session->name, 't'=>$eg->session->token, 'action'=>'twitter_auth'));
    }

    function login() {
        global $eg;
        if(!$this->configured){
            return;
        }

        if(!$eg->networks['twitter']['id']){
            $req = "INSERT INTO `" . $eg->config['db_prefix'] . "networks`  (`session_id`, `status`,  `name`, `preferences`) VALUES ('" . $eg->session->id . "', '1', 'twitter', '')";
        }
        else{
            $req = "UPDATE `" . $eg->config['db_prefix'] . "networks` SET `status`='1' WHERE " . $eg->db_where() . " `name`='twitter'";
        }
        mysqli_query($eg->mysqli, $req);

        $redirect = $eg->admin_url . 'networks.php?' . http_build_query(
            array(
                's' => $eg->session->name,
                't' => $eg->session->token,
                'confirm' => true,
                'action'=>'twitter_auth',
                )
            );
        if (!isset($_GET['oauth_verifier']) || !isset($_SESSION['oauth_verify'])) {
            // get the request token
            $reply = $this->instance->oauth_requestToken([
                'oauth_callback' => $redirect
            ]);
            if($reply->httpstatus==200){

                // store the token
                $this->instance->setToken($reply->oauth_token, $reply->oauth_token_secret);
                $_SESSION['oauth_token'] = $reply->oauth_token;
                $_SESSION['oauth_token_secret'] = $reply->oauth_token_secret;
                $_SESSION['oauth_verify'] = true;

                ob_get_clean();

                // redirect to auth website
                $auth_url = $this->instance->oauth_authorize();
                header('Location: ' . $auth_url);
                die();
            }
            else{
              panic(__('An error occured.'), $reply);
            }
        }
        else {
            // verify the token
            $this->instance->setToken($_SESSION['oauth_token'], $_SESSION['oauth_token_secret']);
            unset($_SESSION['oauth_verify']);

            // get the access token
            $reply = $this->instance->oauth_accessToken([
                'oauth_verifier' => $_GET['oauth_verifier']
            ]);

            // store the token (which is different from the request token!)
            $this->save_access_token( $reply->oauth_token,  $reply->oauth_token_secret);

            ob_get_clean();

            // send to same URL, without oauth GET parameters
            header('Location: ' . $redirect);
            die();
        }
    }

    function save_access_token($token, $secret){
        global $eg;
        if($eg->networks['twitter']['options']['token'] != $token){
            $eg->networks['twitter']['options']['token'] = $token;
            $eg->networks['twitter']['options']['secret'] = $secret;

            //update_option('commonsco_config', $eg->config);
            $options = serialize($eg->networks['twitter']['options']);
            $req = "UPDATE `" . $eg->config['db_prefix'] . "networks` SET `status`='1', `preferences`='" . $options . "' WHERE " . $eg->db_where() . " `name`='twitter'";
            return mysqli_query($eg->mysqli, $req);
        }
    }

    function get_tweets($query=null){
        global $eg;
        if(!$this->exists() || !$this->is_connected()){
            return array();
        }
        if(!$query){
            $query='';
            if(!empty($eg->networks['twitter']['options']['query'])){
                $query = $eg->networks['twitter']['options']['query'].' ';
            }
            if(!empty($eg->networks['twitter']['options']['user'])){
                $users_string = str_replace('@', '', $eg->networks['twitter']['options']['user']);
                $users = preg_split('/[, ;\/]/', $users_string);
                if($query!=''){
                    $query.= 'AND ';
                }
                if(count($users)==1){
                    $query.='from:'.$users[0].' ';
                }
                else{
                    $query.='(';
                    $nu=0;
                    foreach ($users as $user){
                        if(trim($user)!=''){
                            $query.='from:'.$user.' OR ';
                            $nu++;
                        }
                    }
                    if($nu){
                        $query = substr($query, 0, -4);
                    }
                    $query.=') ';
                }
                $query = substr($query, 0, -1);
            }
        }

        if($query==''){
            $query= 'from:'.$this->profile->screen_name;
        }

        $query_array = array(
           'q'=> $query,
           'count'=>30,
           'tweet_mode'=>'extended',
        );

        $last_tweet = $eg->get(array('network'=>'twitter', 'per_page'=>1, 'status'=>0));
        if(count($last_tweet)){
            $query_array['since_id']=$last_tweet[0]->pub_id;
        }

        $query_string = http_build_query($query_array);

        $eg->log($query_string, 'Twitter');
        echo"\nQUERY: «".$query_string."»\n";
        $result = $this->instance->search_tweets($query_string);
        $eg->log(json_encode($result), 'Twitter');
        return isset($result->statuses) ? $result->statuses : array();
    }

    function statuses_lookup($ids=null){
        if(is_array($ids) && count($ids)){
            $query_array = array(
                'id'=>implode(',', $ids)
            );
            $query_string = http_build_query($query_array);
            return $this->instance->statuses_lookup($query_string);
        }
    }

    function get_user($id_or_username){
        $query_array = array();
        if(is_numeric($id_or_username)){
            $query_array['user_id'] = $id_or_username;
        }
        elseif(is_string($id_or_username)){
            $query_array['screen_name'] = $id_or_username;
        }
        $query_string = http_build_query($query_array);
        return $this->instance->users_show($query_string);
    }

    function add($tweet){
        global $eg;

        return $eg->add(array(
            'text' => isset($tweet->full_text) ? $tweet->full_text : $tweet->text,
            'username' => $tweet->user->screen_name,
            'network' => 'twitter',
            'pub_id' => $tweet->id_str,
            'url' => 'https://twitter.com/' . $tweet->user->screen_name . '/statuses/' . $tweet->id_str,
            'date' => $tweet->created_at,
            'media_url' => isset($tweet->extended_entities->media[0]->media_url_https) ? $tweet->extended_entities->media[0]->media_url_https : '',
            'media_type' => isset($tweet->extended_entities->media[0]->type) ? $tweet->entities->media[0]->type : '',
            'user_description' => isset($tweet->user->description) ? $tweet->user->description : '',
            'user_city' => isset($tweet->user->city) ? $tweet->user->city : '',
            'expanded_url' => isset($tweet->entities->media[0]->expanded_url) ? $tweet->entities->media[0]->expanded_url : (isset($tweet->entities->urls[0]->expanded_url) ? $tweet->entities->urls[0]->expanded_url : ''),
            'pub_lat' => isset($tweet->place->bounding_box->coordinates[0][0][1]) ? $tweet->place->bounding_box->coordinates[0][0][1] : '',
            'pub_lon' => isset($tweet->place->bounding_box->coordinates[0][0][0]) ? $tweet->place->bounding_box->coordinates[0][0][0] : '',
            'pub_ref' => isset($tweet->retweeted_status->id) ? $tweet->retweeted_status->id : (isset($tweet->quoted_status->id) ? '>'.$tweet->quoted_status->id : ''),
            'pub_reply_to' => isset($tweet->in_reply_to_status_id_str) ? $tweet->in_reply_to_status_id_str : '',
            'user_avatar' => $tweet->user->profile_image_url_https,
            'search' => $eg->networks['twitter']['options']['query']
        ));
    }

}
