<?php
require_once ('vendor/autoload.php');

\Codebird\Codebird::setConsumerKey($eg->networks['twitter']['options']['consumer_key'], $eg->networks['twitter']['options']['consumer_secret']); // static, see README

$cb = \Codebird\Codebird::getInstance();

// assign access token on each page load
$cb->setToken($eg->networks['twitter']['options']['token'], $eg->networks['twitter']['options']['secret']);


function eg_cb_streaming_callback($data){
  global $eg;
  // gets called for every new streamed message
  // gets called with $message = NULL once per second

  if ($data !== null) {
    echo "\nAdd tweet\n";

    $media_url=isset($data->entities->media[0]->media_url_https) ? $data->entities->media[0]->media_url_https : '';

    $eg -> add(array(
        'text' => $data->text,
        'username' => $data->user->screen_name,
        'network' => 'twitter',
        'pub_id' => $data->id_str,
        'url' => $url = 'https://twitter.com/' . $data->user->screen_name . '/statuses/' . $data->id_str,
        'date' => $data->created_at,
        'media_url' => $media_url,
        'user_description' => isset($data->user->description) ? $data->user->description : '',
        'user_city' => isset($data->user->city) ? $data->user->city : '',
        'expanded_url' => isset($data->entities->urls[0]->expanded_url) ? $data->entities->urls[0]->expanded_url : '',
        'pub_lat' => isset($data->place->bounding_box->coordinates[0][0][1]) ? $data->place->bounding_box->coordinates[0][0][1] : '',
        'pub_lon' => isset($data->place->bounding_box->coordinates[0][0][0]) ? $data->place->bounding_box->coordinates[0][0][0] : '',
        'pub_ref' => isset($data->retweeted_status) ? $data->retweeted_status->id : '',
        'user_avatar' => $data->user->profile_image_url_https,
        'search'=>$eg->networks['twitter']['options']['query']
    ));
    if (isset($data->retweeted_status) && $eg->session->advanced_repost) {
        $retweeted_media_url=isset($data->retweeted_status->entities->media[0]->media_url_https) ? $data->retweeted_status->entities->media[0]->media_url_https : $media_url;
        $eg -> add(array(
            'text' => $data->retweeted_status->text,
            'username' => $data->retweeted_status->user->screen_name,
            'network' => 'twitter',
            'pub_id' => $data->retweeted_status->id,
            'url' => $url = 'https://twitter.com/' . $data->retweeted_status->user->screen_name . '/statuses/' . $data->retweeted_status->id,
            'date' => $data->retweeted_status->created_at,
            'media_url' => $retweeted_media_url,
            'user_description' => isset($data->retweeted_status->user->description) ? $data->retweeted_status->user->description : '',
            'user_city' => isset($data->retweeted_status->user->city) ? $data->retweeted_status->user->city : '',
            'expanded_url' => isset($data->retweeted_status->entities->urls[0]->expanded_url) ? $data->retweeted_status->entities->urls[0]->expanded_url : '',
            'pub_lat' => isset($data->retweeted_status->place->bounding_box->coordinates[0][0][1]) ? $data->retweeted_status->place->bounding_box->coordinates[0][0][1] : '',
            'pub_lon' => isset($data->retweeted_status->place->bounding_box->coordinates[0][0][0]) ? $data->retweeted_status->place->bounding_box->coordinates[0][0][0] : '',
            'pub_ref' => isset($data->retweeted_status->retweeted_status) ? $data->retweeted_status->retweeted_status->id : '',
            'user_avatar' => $data->retweeted_status->user->profile_image_url_https,
            'search'=>$eg->networks['twitter']['options']['query']
        ));
    }
    flush();
  }

  // return false to continue streaming
  // return true to close the stream

  // close streaming after 1 minute for this simple sample
  // don't rely on globals in your code!
  if (time() > $GLOBALS['time_limit']) {
    echo"\nOK, I'm done.\n";
    return true;
  }

  return false;
}

// set the streaming callback in Codebird
$cb->setStreamingCallback('eg_cb_streaming_callback');


// Set delay limit
$time_delay = abs($eg -> networks['twitter']['options']['ttr']);
$time_limit = time() + ($time_delay * 60);
$GLOBALS['time_limit'] = $time_limit;


// Search query
$query = array();
if(!empty($eg->networks['twitter']['options']['query'])){
    $query['track']=($eg->networks['twitter']['options']['query']);
}
if(!empty($eg->networks['twitter']['options']['user'])){
    $query['follow']=($eg->networks['twitter']['options']['user']);
}
$query_string =  urldecode(http_build_query($query));
echo "\n".$query_string." until ".date('c', $GLOBALS['time_limit'])."\n";
flush();
$cb->statuses_filter($query_string);



