<?php
require('../ecologram.php');
?><!DOCTYPE html>
<!--
To change this license header, choose License Headers in Project Properties.
To change this template file, choose Tools | Templates
and open the template in the editor.
-->
<html>
    <head>
        <meta charset="utf-8">
        <?php $eg->styles(); ?>
        <title><?= $eg->title ?></title>
        <link rel="shortcut icon" href="<?= $eg->base_url ?>/img/slideyournet-icon.png" />
        <link rel="apple-touch-icon" href="<?= $eg->base_url ?>/img/slideyournet-icon.png"/>
        <meta name="viewport" content="width=device-width, initial-scale=1"/>
    </head>
    <body>
        <?php SYN()->template('header'); ?>
        <div class="container">

            <h1>SlideYour.Net API</h1>
            <p>
                Manage your agregated posts
            </p>
            <h2>Posts</h2>
            <p>
                Call the following URL
                <code>
                    http://slideyour.net/api.php
                </code>
            </p>
            <table class="table">
                <thead>
                    <tr>
                        <th>Parameters</th>
                        <th>Values</th>
                        <th>Infos</th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td>s</td>
                        <td>Your instance's name</td>
                        <td>Required</td>
                    </tr>
                    <tr>
                        <td>t</td>
                        <td>Your instance's token</td>
                        <td>Required</td>
                    </tr>
                    <tr>
                        <td>object</td>
                        <td>post</td>
                        <td>Required</td>
                    </tr>
                    <tr>
                        <td>type</td>
                        <td>get, add or stat</td>
                        <td>List posts, create a new one or just give the count</td>
                    </tr>
                    <tr>
                        <td>network</td>
                        <td>empty, twitter or instagram</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>username</td>
                        <td>empty or user's name</td>
                        <td>Requires network to be filled</td>
                    </tr>
                    <tr>
                        <td>status</td>
                        <td>1 or 0</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>after</td>
                        <td>empty or date 0000-00-00 00:00:00</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>before</td>
                        <td>empty or date 0000-00-00 00:00:00</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>minid</td>
                        <td>empty or integer</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>maxid</td>
                        <td>empty or integer</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>item_id</td>
                        <td>empty or integer</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>ref</td>
                        <td>"no", "yes" or integer</td>
                        <td>ID of the original mentionned post, <em>eg: retwitted post ID</em></td>
                    </tr>
                    <tr>
                        <td>order</td>
                        <td>DESC or ASC</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>order_by</td>
                        <td>pub_date, id, content</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>per_page</td>
                        <td>default : 10</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>page</td>
                        <td>default 1</td>
                        <td></td>
                    </tr>
                </tbody>
            </table>

            <h2>Users</h2>
            <p>
                Call the following URL
                <code>
                    http://slideyour.net/api.php
                </code>
            </p>
            <table class="table">
                <thead>
                    <tr>
                        <th>Parameters</th>
                        <th>Values</th>
                        <th>Infos</th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td>s</td>
                        <td>Your instance's name</td>
                        <td>Required</td>
                    </tr>
                    <tr>
                        <td>t</td>
                        <td>Your instance's token</td>
                        <td>Required</td>
                    </tr>
                    <tr>
                        <td>object</td>
                        <td>user</td>
                        <td>Required</td>
                    </tr>
                    <tr>
                        <td>network</td>
                        <td>empty, twitter or instagram</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>status</td>
                        <td>1 or 0</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>minid</td>
                        <td>empty or integer</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>maxid</td>
                        <td>empty or integer</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>order</td>
                        <td>DESC or ASC</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>order_by</td>
                        <td>id, username</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>per_page</td>
                        <td>default : 10</td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>page</td>
                        <td>default 1</td>
                        <td></td>
                    </tr>
                </tbody>
            </table>

            <footer>
                <p>
                    <a href="https://slideyour.net">
                        SlideYour.net
                    </a>
                    By
                    <a href="https://www.avecnous.eu">
                        N.O.U.S. Ouvert Utile et Simple
                    </a>
                </p>
            </footer>
        </div>
        <?php SYN()->template('footer'); ?>
    </body>
</html>
