-- phpMyAdmin SQL Dump
-- version 5.1.1
-- https://www.phpmyadmin.net/
--
-- Host: localhost
-- Generation Time: Feb 22, 2022 at 11:38 AM
-- Server version: 10.5.13-MariaDB-0ubuntu0.21.10.1
-- PHP Version: 8.0.15

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
START TRANSACTION;
SET time_zone = "+00:00";

-- --------------------------------------------------------

--
-- Table structure for table `{DB_PREFIX}api_call`
--

CREATE TABLE `{DB_PREFIX}api_call` (
  `id` int(11) NOT NULL,
  `id_session` int(11) NOT NULL,
  `date` datetime DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- --------------------------------------------------------

--
-- Table structure for table `{DB_PREFIX}cache`
--

CREATE TABLE `{DB_PREFIX}cache` (
  `id` bigint(20) NOT NULL,
  `session_id` bigint(20) NOT NULL,
  `key` varchar(255) NOT NULL,
  `value` mediumblob NOT NULL,
  `expire` datetime NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- --------------------------------------------------------

--
-- Table structure for table `{DB_PREFIX}items`
--

CREATE TABLE `{DB_PREFIX}items` (
  `id` bigint(20) NOT NULL,
  `session_id` bigint(20) NOT NULL,
  `user_id` bigint(20) NOT NULL,
  `network` varchar(100) NOT NULL,
  `pub_date` datetime NOT NULL,
  `pub_url` varchar(255) NOT NULL,
  `pub_id` varchar(100) NOT NULL,
  `pub_lat` varchar(255) NOT NULL,
  `pub_lon` varchar(255) NOT NULL,
  `root_item` bigint(20) DEFAULT NULL COMMENT 'FK to {DB_PREFIX}items ID. Primary ancestor',
  `pub_ref` varchar(255) NOT NULL,
  `pub_reply_to` varchar(255) NOT NULL,
  `content` longtext NOT NULL,
  `media_url` text NOT NULL,
  `media_type` varchar(20) NOT NULL,
  `expanded_url` text NOT NULL,
  `search` varchar(100) NOT NULL,
  `status` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4;

-- --------------------------------------------------------

--
-- Table structure for table `{DB_PREFIX}networks`
--

CREATE TABLE `{DB_PREFIX}networks` (
  `id` bigint(20) NOT NULL,
  `session_id` bigint(20) NOT NULL,
  `name` varchar(100) NOT NULL,
  `status` tinyint(1) NOT NULL,
  `preferences` longtext NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- --------------------------------------------------------

--
-- Table structure for table `{DB_PREFIX}sessions`
--

CREATE TABLE `{DB_PREFIX}sessions` (
  `id` bigint(20) NOT NULL,
  `name` varchar(100) NOT NULL,
  `lang` varchar(7) DEFAULT NULL,
  `email` varchar(200) DEFAULT NULL,
  `token` varchar(255) NOT NULL,
  `mod` tinyint(1) DEFAULT NULL,
  `snapshot` tinyint(1) DEFAULT NULL,
  `duplicate` tinyint(1) DEFAULT NULL,
  `empty` tinyint(1) DEFAULT NULL,
  `advanced_repost` tinyint(1) DEFAULT NULL,
  `date_begin` datetime DEFAULT NULL,
  `date_end` datetime DEFAULT NULL,
  `date_updated` datetime DEFAULT NULL,
  `date_fetched` datetime DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- --------------------------------------------------------

--
-- Table structure for table `{DB_PREFIX}users`
--

CREATE TABLE `{DB_PREFIX}users` (
  `id` bigint(20) NOT NULL,
  `session_id` bigint(20) NOT NULL,
  `name` varchar(100) NOT NULL,
  `external_id` varchar(100) DEFAULT NULL,
  `network` varchar(100) NOT NULL,
  `avatar_url` text DEFAULT NULL,
  `user_description` text NOT NULL,
  `user_city` text NOT NULL,
  `status` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4;

--
-- Indexes for dumped tables
--

--
-- Indexes for table `{DB_PREFIX}api_call`
--
ALTER TABLE `{DB_PREFIX}api_call`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `{DB_PREFIX}cache`
--
ALTER TABLE `{DB_PREFIX}cache`
  ADD PRIMARY KEY (`id`),
  ADD KEY `session_id` (`session_id`);

--
-- Indexes for table `{DB_PREFIX}items`
--
ALTER TABLE `{DB_PREFIX}items`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `network` (`network`,`pub_id`),
  ADD KEY `quand` (`pub_date`),
  ADD KEY `FK_user` (`user_id`),
  ADD KEY `FK_primary_ancestor` (`root_item`),
  ADD KEY `FK_session` (`session_id`) USING BTREE;

--
-- Indexes for table `{DB_PREFIX}networks`
--
ALTER TABLE `{DB_PREFIX}networks`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `networks` (`session_id`,`name`);

--
-- Indexes for table `{DB_PREFIX}sessions`
--
ALTER TABLE `{DB_PREFIX}sessions`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `name` (`name`),
  ADD UNIQUE KEY `token` (`token`);

--
-- Indexes for table `{DB_PREFIX}users`
--
ALTER TABLE `{DB_PREFIX}users`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `name` (`name`,`network`,`session_id`),
  ADD KEY `FK_session` (`session_id`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `{DB_PREFIX}api_call`
--
ALTER TABLE `{DB_PREFIX}api_call`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `{DB_PREFIX}cache`
--
ALTER TABLE `{DB_PREFIX}cache`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `{DB_PREFIX}items`
--
ALTER TABLE `{DB_PREFIX}items`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `{DB_PREFIX}networks`
--
ALTER TABLE `{DB_PREFIX}networks`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `{DB_PREFIX}sessions`
--
ALTER TABLE `{DB_PREFIX}sessions`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `{DB_PREFIX}users`
--
ALTER TABLE `{DB_PREFIX}users`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT;

--
-- Constraints for dumped tables
--

--
-- Constraints for table `{DB_PREFIX}networks`
--
ALTER TABLE `{DB_PREFIX}networks`
  ADD CONSTRAINT `FK_session` FOREIGN KEY (`session_id`) REFERENCES `{DB_PREFIX}sessions` (`id`),
  ADD CONSTRAINT `{DB_PREFIX}networks_ibfk_1` FOREIGN KEY (`session_id`) REFERENCES `{DB_PREFIX}sessions` (`id`);
COMMIT;
